package company

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// CompanyDeleteBak 客户删除的备份数据表
type CompanyDeleteBak struct {
	DeleteBakId                   int       `orm:"column(delete_bak_id);pk"`
	CompanyId                     int       `description:"客户id"`
	CompanyName                   string    `description:"客户名称"`
	CompanyInfo                   string    `description:"客户主表信息"`
	CompanyProductInfo            string    `description:"客户产品信息"`
	CompanyPermissionInfo         string    `description:"客户产品权限信息"`
	UserSellerRelationInfo        string    `description:"联系人与销售关系信息"`
	UserRecordInfo                string    `description:"联系人关系信息"`
	UserInfo                      string    `description:"联系人信息"`
	CompanyChartPermissionInfo    string    `description:"客户图表权限信息"`
	CompanyContractInfo           string    `description:"客户合同信息"`
	CompanyContractPermissionInfo string    `description:"客户合同权限信息"`
	OpUserId                      int       `description:"操作人id"`
	OpUserName                    string    `description:"操作人名称"`
	CreateTime                    time.Time `description:"创建时间"`
}

// AddCompanyDeleteBak 添加客户删除之前的备注
func AddCompanyDeleteBak(companyDeleteBak *CompanyDeleteBak) (err error) {
	o := orm.NewOrm()
	_, err = o.Insert(companyDeleteBak)
	return
}
