package company

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CompanyProductLog struct {
	Id               int       `orm:"column(id);pk"`
	CompanyProductId int       `description:"产品id"`
	CompanyId        int       `description:"客户id"`
	ProductId        int       `description:"产品id"`
	ProductName      string    `description:"产品名称"`
	CompanyName      string    `description:"客户名称"`
	Source           string    `description:"来源"`
	Reasons          string    `description:"新增理由"`
	Status           string    `description:"客户状态"`
	IndustryId       int       `description:"行业id"`
	IndustryName     string    `description:"行业名称"`
	SellerId         int       `description:"所属销售id"`
	SellerName       string    `description:"所属销售名称"`
	GroupId          int       `description:"所属销售分组id"`
	DepartmentId     int       `description:"所属销售部门id"`
	IsSuspend        int       `description:"1:暂停,0:启用"`
	SuspendTime      time.Time `description:"暂停时间"`
	FreezeTime       time.Time `description:"冻结时间"`
	Remark           string    `description:"备注信息"`
	StartDate        string    `description:"开始日期"`
	EndDate          string    `description:"结束日期"`
	CreateTime       time.Time `description:"创建时间"`
	ModifyTime       time.Time `description:"修改时间"`
	LoseReason       string    `description:"流失原因"`
	LossTime         time.Time `description:"流失时间"`
	LogType          string    `description:"日志类型"`
	LogCreateTime    time.Time `description:"日志创建时间"`
	AdminId          int       `description:"操作人id"`
	ApproveStatus    string    `description:"审批状态:'审批中','通过','驳回'"`
	FreezeStartDate  string    `description:"冻结开始日期"`
	FreezeEndDate    string    `description:"冻结结束日期"`
	Scale            string    `description:"管理规模，空不填，1：:50亿以下，2：50~100亿，3：100亿以上。"`
}

//新增客户产品
func AddCompanyProductLog(item *CompanyProductLog) (err error) {
	o := orm.NewOrm()
	_, err = o.Insert(item)
	return
}
