package company

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// WxUserOpLog 联系人操作日志表
type WxUserOpLog struct {
	Id                     int       `orm:"column(id);pk"`
	LogType                string    `description:"日志类型：add，edit，move"`
	UserId                 int       `description:"联系人id"`
	CompanyId              int       `description:"客户id"`
	Mobile                 string    `description:"当前手机号"`
	Email                  string    `description:"当前邮箱"`
	OriginalUserInfo       string    `description:"变更前的联系人信息"`
	UserInfo               string    `description:"当前联系人信息"`
	OriginalUserSellerInfo string    `description:"变更前的联系人销售归属"`
	UserSellerInfo         string    `description:"当前联系人销售归属"`
	OpUserId               int       `description:"操作人编号"`
	OpUserName             string    `description:"操作人名称"`
	CreateTime             time.Time `description:"日志创建时间"`
}

// AddWxUserOpLog 新增客户产品
func AddWxUserOpLog(item *WxUserOpLog) (err error) {
	o := orm.NewOrm()
	_, err = o.Insert(item)
	return
}
