package company_report_permission_log

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

// 用户权限操作日志表
type CompanyReportPermissionLog struct {
	Id                        int64     `orm:"column(id);pk"`
	CompanyReportPermissionId int64     `description:"用户权限id"`
	CompanyId                 int       `description:"公司id"`
	ProductId                 int       `description:"产品id"`
	ProductName               string    `description:"产品名称"`
	SysUserId                 int       `description:"操作者id"`
	SysUserName               string    `description:"操作者名称"`
	Remark                    string    `description:"备注"`
	Operation                 string    `description:"操作"`
	Status                    string    `description:"状态"`
	CreateTime                time.Time `description:"操作时间"`
}

// 添加用户权限操作日志
func AddCompanyReportPermissionLog(item *CompanyReportPermissionLog) (lastId int64, err error) {
	o := orm.NewOrm()
	lastId, err = o.Insert(item)
	return
}

// MultiCreateCompanyReportPermissionLog 批量添加客户权限操作日志
func MultiCreateCompanyReportPermissionLog(items []*CompanyReportPermissionLog) (err error) {
	if len(items) == 0 {
		return
	}
	o := orm.NewOrm()
	_, err = o.InsertMulti(len(items), items)
	return
}
