package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/company"
	"hongze/hz_crm_api/models/contract"
	"time"
)

type AddContractResp struct {
	ContractId int `description:"合同id"`
}

// ContractListResp 合同列表数据
type ContractListResp struct {
	Paging *paging.PagingItem
	List   []*contract.ContractList `description:"列表数据"`
}

type ContractOperationListResp struct {
	List []ContractOperationRecordListResp `description:"列表数据"`
}

type ContractOperationRecordListResp struct {
	Id               int       ``
	ContractId       int       `description:"合同id"`
	Operation        string    `description:"操作类型，add：新增，edit：编辑，apply：发起审批，cancel_apply：撤回审批，reject：拒绝审批，approval：审批操作;长度36位"`
	OpUserId         int       `description:"操作人id"`
	OpUserName       string    `description:"操作人名称"`
	Remark           string    `description:"备注，长度255位"`
	ApprovalRecordId int       `orm:"column(approval_record_id)";description:"审批流id"`
	CreateTime       time.Time `description:"日志添加时间"`
	CreateTimeStr    string    `description:"日志添加时间"`
}

// 审批列表
type ContractApprovalListResp struct {
	Paging *paging.PagingItem
	List   []*contract.ContractApprovalList `description:"列表数据"`
}

// 合同预览的html数据返回
type ContractPreviewResp struct {
	Html string `description:"合同预览的html数据"`
}

// 申请转正、服务更新时的合同详情
type ContractApplyDetailResp struct {
	ContractDetail *contract.ContractDetail      `description:"合同数据"`
	PermissionList []*company.PermissionLookList `description:"权限列表"`
}

// 用印审批搜索的合同列表
type ContractListBySealResp struct {
	ContractId           int     `description:"合同ID"`
	ContractCode         string  `description:"合同编号,长度32位"`
	ContractBusinessType string  `description:"合同业务类型，枚举值：'业务合同','代付合同'"`
	ContractType         string  `description:"合同类型，枚举值：'新签合同','续约合同','补充协议'"`
	CompanyName          string  `description:"客户名称，甲方名称,长度32位"`
	UserCompanyName      string  `description:"实际使用方"`
	CreditCode           string  `description:"社会统一信用代码"`
	Price                float64 `description:"实际金额，优惠后的金额"`
	FileUrl              string  `description:"合同文件地址"`
}
