package cygx

import (
	"github.com/beego/beego/v2/client/orm"
)

type CygxQuestionnaireVoteResp struct {
	QuestionnaireVoteId  int    `orm:"column(questionnaire_vote_id);pk"`
	QuestionnaireId      int    `description:"问卷ID"`
	QuestionnaireThemeId int    `description:"问卷主题ID"`
	UserId               int    `description:"用户ID"`
	CreateTime           string `description:"创建时间"`
	Mobile               string `description:"手机号"`
	Email                string `description:"邮箱"`
	CompanyId            int    `description:"公司id"`
	CompanyName          string `description:"公司名称"`
	ModifyTime           string `description:"修改时间"`
	RealName             string `description:"用户实际名称"`
	SellerName           string `description:"所属销售"`
	RegisterPlatform     int    `description:"来源 1小程序，2：网页"`
}

type CygxQuestionnaireVoteOtherThemeResp struct {
	QuestionnaireVoteOtherThemeId int `orm:"column(questionnaire_vote_other_theme_id);pk"`
	QuestionnaireId               int `description:"问卷ID"`
	UserId                        int `description:"用户ID"`
	CreateTime                    string
	Mobile                        string `description:"手机号"`
	Email                         string `description:"邮箱"`
	CompanyId                     int    `description:"公司id"`
	CompanyName                   string `description:"公司名称"`
	ModifyTime                    string `description:"修改时间"`
	RealName                      string `description:"用户实际名称"`
	SellerName                    string `description:"所属销售"`
	Content                       string `description:"内容"`
	RegisterPlatform              int    `description:"来源 1小程序，2：网页"`
}

type CygxQuestionnaireVoteReq struct {
	QuestionnaireId       int    `description:"问卷ID"`
	QuestionnaireThemeIds []int  `description:"问卷主题ID"`
	Content               string `description:"内容"`
}

type CygxQuestionnaireVoteListResp struct {
	List []*AddCygxQuestionnaireThemeReq
}

// 列表
func GetCygxCygxQuestionnaireVoteListByQuestionnaireId(questionnaireId int) (items []*CygxQuestionnaireVoteResp, err error) {
	o := orm.NewOrmUsingDB("hz_cygx")
	sql := `SELECT * FROM cygx_questionnaire_vote as art WHERE questionnaire_id = ? `
	_, err = o.Raw(sql, questionnaireId).QueryRows(&items)
	return
}

type CygxCygxQuestionnaireVoteListResp struct {
	List []*CygxQuestionnaireVoteResp
}

// 列表
func GetCygxQuestionnaireVoteListByQuestionnaireThemeId(questionnaireThemeId int) (items []*CygxQuestionnaireVoteResp, err error) {
	o := orm.NewOrmUsingDB("hz_cygx")
	sql := `SELECT * FROM cygx_questionnaire_vote as art WHERE questionnaire_theme_id = ?  ORDER BY create_time DESC  `
	_, err = o.Raw(sql, questionnaireThemeId).QueryRows(&items)
	return
}

type CygxQuestionnaireVoteOtherThemeListResp struct {
	List []*CygxQuestionnaireVoteOtherThemeResp
}

// 列表
func GetCygxQuestionnaireVoteOtherThemeListByQuestionnaireId(questionnaireId int) (items []*CygxQuestionnaireVoteOtherThemeResp, err error) {
	o := orm.NewOrmUsingDB("hz_cygx")
	sql := `SELECT * FROM cygx_questionnaire_vote_other_theme as art WHERE questionnaire_id = ?   ORDER BY create_time DESC  `
	_, err = o.Raw(sql, questionnaireId).QueryRows(&items)
	return
}
