package cygx

import (
	"github.com/beego/beego/v2/client/orm"
	"time"
)

type CygxReportHistoryRecord struct {
	Id               int `orm:"column(id);pk"`
	ArticleId        int
	UserId           int
	CreateTime       time.Time
	Mobile           string    `description:"手机号"`
	Email            string    `description:"邮箱"`
	CompanyId        int       `description:"公司id"`
	CompanyName      string    `description:"公司名称"`
	ModifyTime       time.Time `description:"修改时间"`
	ReportType       string    `description:"报告类型，bgjx:报告精选、bzyjhz:本周研究汇总、szjyhz:上周纪要汇总"`
	RealName         string    `description:"用户实际名称"`
	SellerName       string    `description:"所属销售"`
	StopTime         int       `description:"停留时间"`
	OutType          int       `description:"退出方式，1正常退出，2强制关闭"`
	RegisterPlatform int       `description:"来源 1小程序，2：网页"`
}

// 根据用户ID，文章ID获取用户最新一条阅读记录
func GetCygxReportHistoryRecordDetailLast(articleId int, mobile, reportType string) (item *CygxArticleHistoryRecordAll, err error) {
	o := orm.NewOrmUsingDB("hz_cygx")
	sql := `SELECT * FROM cygx_report_history_record WHERE   article_id = ?  AND mobile = ?   AND report_type = ?    ORDER BY id DESC    LIMIT 1 `
	err = o.Raw(sql, articleId, mobile, reportType).QueryRow(&item)
	return
}
