package request

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/cygx"
)

// MoveTagReq 移动标签请求参数
type MoveTagReq struct {
	TagId     int `description:"指标id"`
	PrevTagId int `description:"上一个节点标签id"`
	NextTagId int `description:"下一个节点标签id"`
}

// SaveTagReq 保存标签请求参数
type SaveTagReq struct {
	TagId         int    `description:"指标id"`
	TagName       string `description:"标签名"`
	ArticleTypes  string `description:"报告系列"`
	ActivityTypes string `description:"活动类型"`
	Industries    string `description:"产业"`
	SubjectNames  string `description:"标的"`
}

type TagListResp struct {
	Paging *paging.PagingItem `description:"分页数据"`
	List   []*cygx.CygxTagList
}
