package request

import "hongze/hz_crm_api/models/data_manage"

// SaveMultipleGraphConfigReq 多图配置请求
type SaveMultipleGraphConfigReq struct {
	MultipleGraphConfigId int                                    `description:"配置id"`
	EdbInfoIdA            int                                    `description:"指标A"`
	EdbInfoIdB            int                                    `description:"指标B"`
	Curve                 data_manage.CurveConfig                `description:"曲线图配置"`
	Correlation           data_manage.CorrelationConfig          `description:"相关性配置"`
	RollingCorrelation    []data_manage.RollingCorrelationConfig `description:"滚动相关性配置"`
}

// SaveMultipleGraphChartReq 多图配置的单图保存请求
type SaveMultipleGraphChartReq struct {
	Source                int                                    `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
	ChartName             string                                 `description:"图表名称"`
	ClassifyId            int                                    `description:"分类id"`
	MultipleGraphConfigId int                                    `description:"配置id"`
	EdbInfoIdA            int                                    `description:"指标A"`
	EdbInfoIdB            int                                    `description:"指标B"`
	Curve                 data_manage.CurveConfig                `description:"曲线图配置"`
	Correlation           data_manage.CorrelationConfig          `description:"相关性配置"`
	RollingCorrelation    []data_manage.RollingCorrelationConfig `description:"滚动相关性配置"`
	IsSaveAs              bool                                   `description:"是否另存为，true的话，就是另存为，不会建立与配置的关系"`
}

// SaveMultipleGraphEdbReq 多图配置的单指标保存请求
type SaveMultipleGraphEdbReq struct {
	EdbName    string `description:"指标名称"`
	Frequency  string `description:"频度"`
	Unit       string `description:"单位"`
	ClassifyId int    `description:"分类id"`

	Source                int                                    `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
	MultipleGraphConfigId int                                    `description:"配置id"`
	EdbInfoIdA            int                                    `description:"指标A"`
	EdbInfoIdB            int                                    `description:"指标B"`
	Curve                 data_manage.CurveConfig                `description:"曲线图配置"`
	Correlation           data_manage.CorrelationConfig          `description:"相关性配置"`
	RollingCorrelation    []data_manage.RollingCorrelationConfig `description:"滚动相关性配置"`
	IsSaveAs              bool                                   `description:"是否另存为，true的话，就是另存为，不会建立与配置的关系"`
}

type EdbCalculateFormula struct {
	BaseCalculateValue int    `description:"基础计算窗口"`
	BaseCalculateUnit  string `description:"基础计算频度"`
	LeadValue          int    `description:"领先期数"`
	LeadUnit           string `description:"频度"`
	CalculateValue     int    `description:"计算窗口"`
	CalculateUnit      string `description:"计算频度"`
}
