package request

// AddBaseFromMysteelChemicalClassifyReq 添加钢联化工分类请求
type AddBaseFromMysteelChemicalClassifyReq struct {
	ParentId     int    `description:"上级id"`
	ClassifyName string `description:"分类名称"`
	Level        int    `description:"层级,第一级传0，其余传上一级的层级"`
}

// EditBaseFromMysteelChemicalClassifyReq 修改钢联化工分类请求
type EditBaseFromMysteelChemicalClassifyReq struct {
	ClassifyName                      string `description:"分类名称"`
	BaseFromMysteelChemicalClassifyId int    `description:"分类id"`
}

// MoveBaseFromMysteelChemicalClassifyReq 移动分类请求参数
type MoveBaseFromMysteelChemicalClassifyReq struct {
	BaseFromMysteelChemicalClassifyId       int `description:"分类id"`
	ParentBaseFromMysteelChemicalClassifyId int `description:"父级分类id"`
	PrevBaseFromMysteelChemicalClassifyId   int `description:"上一个兄弟节点分类id"`
	NextBaseFromMysteelChemicalClassifyId   int `description:"下一个兄弟节点分类id"`
}

// DelBaseFromMysteelChemicalClassifyReq 删除钢联化工分类请求
type DelBaseFromMysteelChemicalClassifyReq struct {
	BaseFromMysteelChemicalClassifyId int `description:"分类id"`
}

// AddBaseFromMysteelChemicalReq 添加钢联化工请求
type AddBaseFromMysteelChemicalReq struct {
	BaseFromMysteelChemicalIndexId    int    `description:"指标id"`
	BaseFromMysteelChemicalClassifyId int    `description:"分类id"`
	IndexCode                         string `description:"指标id"`
	UpdateWeek                        string `description:"更新周期"`
	UpdateTime                        string `description:"更新时间点，多个时间点用英文,隔开"`
}

// DelBaseFromMysteelChemicalReq 删除钢联化工请求
type DelBaseFromMysteelChemicalReq struct {
	BaseFromMysteelChemicalIndexId int `description:"指标id"`
}

// MoveBaseFromMysteelChemicalReq 移动指标请求参数
type MoveBaseFromMysteelChemicalReq struct {
	BaseFromMysteelChemicalClassifyId  int `description:"父级分类id"`
	BaseFromMysteelChemicalIndexId     int `description:"指标id"`
	PrevBaseFromMysteelChemicalIndexId int `description:"上一个兄弟节点分类id"`
	NextBaseFromMysteelChemicalIndexId int `description:"下一个兄弟节点分类id"`
}
