package request

// AddVarietyReq 添加品种请求
type AddVarietyReq struct {
	VarietyName string `description:"品种名称"`
	AdminIdList []int  `description:"有权限用户"`
}

// EditVarietyReq 编辑品种请求
type EditVarietyReq struct {
	VarietyId   int    `description:"品种id"`
	VarietyName string `description:"品种名称"`
	AdminIdList []int  `description:"有权限用户"`
}

// DelVarietyReq 删除品种请求
type DelVarietyReq struct {
	VarietyId int `description:"品种id"`
}

// AnalysisReq 分析品种请求
type AnalysisReq struct {
	VarietyId int `description:"品种id"`
}

// AddVarietyPlantReq 添加品种装置请求
type AddVarietyPlantReq struct {
	VarietyId                     int     `description:"品种id"`
	Province                      string  `description:"所属省份"`
	City                          string  `description:"所属城市"`
	FactoryName                   string  `description:"工厂名称"`
	PlantName                     string  `description:"装置/产线名称"`
	MaintenanceDate               string  `description:"检修日期"`
	ResumptionDate                string  `description:"复产日期"`
	AnnualCapacity                float64 `description:"年产能"`
	Coefficient                   float64 `description:"降负系数"`
	AverageDailyCapacityReduction float64 `description:"日均产量减量"`
	IsStop                        int     `description:"是否停产，0：未停产；1：停产；默认未停产"`
	PrevVarietyPlantId            int     `description:"上一个品种装置id"`
	NextVarietyPlantId            int     `description:"下一个品种装置id"`
}

// EditVarietyPlantReq 编辑品种装置请求
type EditVarietyPlantReq struct {
	VarietyPlantId                int     `description:"品种装置id"`
	Province                      string  `description:"所属省份"`
	City                          string  `description:"所属城市"`
	FactoryName                   string  `description:"工厂名称"`
	PlantName                     string  `description:"装置/产线名称"`
	MaintenanceDate               string  `description:"检修日期"`
	ResumptionDate                string  `description:"复产日期"`
	AnnualCapacity                float64 `description:"年产能"`
	Coefficient                   float64 `description:"降负系数"`
	AverageDailyCapacityReduction float64 `description:"日均产量减量"`
	IsStop                        int     `description:"是否停产，0：未停产；1：停产；默认未停产"`
}

// DeleteVarietyPlantReq 删除品种装置请求
type DeleteVarietyPlantReq struct {
	VarietyPlantId int `description:"品种装置id"`
}

type AddEdbInfoReq struct {
	VarietyEdbId int    `description:"指标id"`
	EdbName      string `description:"指标名称"`
	Frequency    string `description:"频率"`
	Unit         string `description:"单位"`
	ClassifyId   int    `description:"分类id"`
}

// CopyVarietyPlantReq 复制品种装置请求
type CopyVarietyPlantReq struct {
	VarietyId          int   `description:"品种id"`
	PrevVarietyPlantId int   `description:"上一个品种装置id"`
	VarietyPlantIdList []int `description:"品种装置id列表"`
}

// ModifyProductionDayReq 编辑品种的生产天数请求
type ModifyProductionDayReq struct {
	VarietyId int `description:"品种id"`
	Day       int `description:"生产天数"`
}
