package response

import "hongze/hz_crm_api/models/data_manage"

// PreviewMultipleGraphConfigResp 预览
type PreviewMultipleGraphConfigResp struct {
	CurveData              CurveResp     `description:"曲线图数据"`
	CorrelationData        interface{}   `description:"相关性数据"`
	RollingCorrelationData []interface{} `description:"滚动相关性配置"`
}

type CurveResp struct {
	ChartInfo   data_manage.ChartInfoView
	EdbInfoList []data_manage.ChartEdbInfoMapping
}

type CorrelationResp struct {
	ChartInfo            data_manage.ChartInfoView
	EdbInfoList          []*data_manage.ChartEdbInfoMapping
	XEdbIdValue          []int                       `description:"柱方图的x轴数据，指标id"`
	YDataList            []data_manage.YData         `description:"柱方图的y轴数据"`
	CorrelationChartInfo data_manage.CorrelationInfo `description:"相关性图表信息"`
}

// RollingCorrelationResp 滚动相关性图表
type RollingCorrelationResp struct {
	ChartInfo            data_manage.ChartInfoView
	EdbInfoList          []*data_manage.ChartEdbInfoMapping
	XDateTimeValue       []string                    `description:"柱方图的x轴数据，指标id"`
	YDataList            []data_manage.YData         `description:"柱方图的y轴数据"`
	CorrelationChartInfo data_manage.CorrelationInfo `description:"相关性图表信息"`
}

// MultipleGraphConfigDetailResp 配置详情接口返回
type MultipleGraphConfigDetailResp struct {
	EdbInfoList         []*data_manage.ChartEdbInfoMapping
	MultipleGraphConfig data_manage.MultipleGraphConfig   `description:"配置信息"`
	ChartMappingList    []MultipleGraphConfigChartMapping `description:"关联图表"`
	EdbMappingList      []MultipleGraphConfigEdbMapping   `description:"关联指标"`
}
type MultipleGraphConfigChartMapping struct {
	ChartInfoId            int `description:"图表id"`
	Source                 int `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
	MultipleLocationSource int `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
}
type MultipleGraphConfigEdbMapping struct {
	EdbInfoId              int `description:"图表id"`
	Source                 int `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
	MultipleLocationSource int `description:"来源,1:曲线图，2：相关性图；3：滚动相关性图1；4：滚动相关性图2；"`
}
