package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/data_manage/supply_analysis"
)

// VarietyListResp 品种列表数据返回
type VarietyListResp struct {
	AddButton bool `description:"添加品种的权限"`
	Paging    *paging.PagingItem
	List      []*supply_analysis.VarietyItem
}

// VarietyDeleteCheckResp 品种删除检测数据返回
type VarietyDeleteCheckResp struct {
	DeleteStatus int    `description:"检测状态:0:默认值，如果为0，继续走其他校验，1:该品种已在指标库生成指标，不可删除"`
	TipsMsg      string `description:"提示信息"`
}

// VarietyPlantListResp 品种装置列表数据返回
type VarietyPlantListResp struct {
	AddButton bool `description:"添加品种的权限"`
	List      []*supply_analysis.VarietyPlantItem
}

// VarietyEdbListResp 品种指标列表数据返回
type VarietyEdbListResp struct {
	List []*supply_analysis.VarietyEdbInfoItem
}

// VarietyEdbDataListResp 指标数据列表返回
type VarietyEdbDataListResp struct {
	DataTime string  `description:"日期"`
	Value    float64 `description:"数据值"`
}
