package roadshow

import (
	"github.com/beego/beego/v2/client/orm"
	"hongze/hz_crm_api/utils"
	"time"
)

type RsReportRecordPermission struct {
	RsReportRecordPermissionId int64     `orm:"column(rs_report_record_permission_id);pk"`
	CompanyId                  int       `description:"公司id"`
	ProductId                  int       `description:"产品id"`
	ProductName                string    `description:"产品名称"`
	ReportPermissionId         int       `description:"权限id(作废)"`
	Status                     string    `description:"状态"`
	CreatedTime                time.Time `description:"创建时间"`
	ChartPermissionId          int       `description:"大分类ID"`
	StartDate                  string    `description:"合同开始日期"`
	EndDate                    string    `description:"合同结束日期"`
	ModifyTime                 string    `description:"更新时间"`
	IsUpgrade                  int       `description:"是否升级，1是，0否"`
	ExpensiveYx                int       `description:"权益研选: 0-3w; 1-5w"`
	RsCalendarId               int       `description:"路演活动id"`
	time.Time
}

// 根据企业用户id和产品id获取所有正式的权限
func GetCompanyProductReportPermissionList(companyId []int, productId int) (items []*RsReportRecordPermission, err error) {
	o := orm.NewOrm()
	sql := `SELECT * FROM company_report_permission  WHERE company_id IN (` + utils.GetOrmInReplace(len(companyId)) + `) and product_id=?  `
	_, err = o.Raw(sql, companyId, productId).QueryRows(&items)
	return
}

func MultiRsReportRecordPermission(items []*RsReportRecordPermission) (err error) {
	o := orm.NewOrm()
	//批量插入
	_, err = o.InsertMulti(len(items), items)
	return
}
