package roadshow

type GetTokenResp struct {
	Code      int       `json:"code"`
	Msg       string    `json:"msg"`
	Time      int       `json:"time"`
	TokenData TokenData `json:"data"`
}

type TokenData struct {
	AccessToken string `json:"access_token"`
	ExpireIn    int    `json:"expire_in"`
}

type UserCalendarList struct {
	Code int            `json:"code"`
	Msg  string         `json:"msg"`
	Time int            `json:"time"`
	Data []UserCalendar `json:"data"`
}

//type UserCalendar struct {
//	ID int `json:"id"`
//	UserId int `json:"user_id"`
//	ProjectName string `json:"project_name"`
//	ProjectID int `json:"project_id"`
//	CustomerID string `json:"customer_id"`
//	ProjectType int `json:"project_type"`
//	ProjectFormType int `json:"project_form_type"`
//	Room int `json:"room"`
//	StartTime int `json:"start_time"`
//	EndTime int `json:"end_time"`
//	Content string `json:"content"`
//	FeedExpert interface{} `json:"feed_expert"`
//	Title string `json:"title"`
//	Start string `json:"start"`
//	End string `json:"end"`
//	BackgroundColor string `json:"backgroundColor"`
//	BorderColor string `json:"borderColor"`
//	TextColor string `json:"textColor"`
//}
type UserCalendar struct {
	ID               int    `json:"id" description:"关系id" `
	UserId           int    `json:"user_id" description:"创建人id" `
	UserPhone        string `json:"user_phone" description:"创建人手机号" `
	UserName         string `json:"user_name" description:"创建人昵称" `
	ProjectName      string `json:"project_name" description:"活动名称" `
	ProjectId        int    `json:"project_id" description:"活动id" `
	CustomerId       string `json:"customer_id" description:"客户id" `
	CustomerName     string `json:"customer_name" description:"客户名称" `
	CustomerSocial   string `json:"customer_social" description:"客户社会信用码" `
	ProjectType      int    `json:"project_type" description:"活动类型：1=沙龙，2=路演，3=专家需求，4=研究需求，5=电话，6=面谈，7=专题需求，8=线下沙龙，9=公司调研"`
	ProjectFormType  int    `json:"project_form_type" description:"服务形式：1=沙龙，2=路演，3=专家需求，4=研究需求，5=电话，6=面谈，7=专题需求"`
	Room             int    `json:"room" description:"会议室id"`
	StartTime        int    `json:"start_time" description:"开始时间戳"`
	EndTime          int    `json:"end_time" description:"结束时间戳"`
	Content          string `json:"content" description:"活动内容"`
	FeedExpert       string `json:"feed_expert" description:"邀请的专家"`
	Title            string `json:"title" description:"日历显示的标题"`
	ResearcherMobile string `json:"researcher_mobile" description:"研究员+协同人员手机号（多个使用逗号拼接）"`
}

type CreatSHCalendarResp struct {
	Code int      `json:"code"`
	Msg  string   `json:"msg"`
	Time int      `json:"time"`
	Data Calendar `json:"data"`
}
type Calendar struct {
	CalendarID string `json:"calendar_id"`
}
