package request

// 用印审批申请请求
type SealApprovalApplyReq struct {
	ContractId        int      `description:"系统合同id"`
	Use               string   `description:"用印用途，枚举值：'销售合同','渠道合同','付款通知函','招投标','战略合作协议','代付合同','总对总协议'；默认：销售合同"`
	CompanyName       string   `description:"客户名称，甲方名称,长度32位"`
	UseCompanyName    string   `description:"实际适用方客户名称，长度32位"`
	CreditCode        string   `description:"社会统一信用代码,长度64位"`
	ServiceType       string   `description:"业务类型，枚举值：'新签合同','续约合同','补充协议'；默认：新签合同"`
	SealType          string   `description:"加盖印章类型，多选，逗号拼接，值：'合同章','公章','法人章'"`
	Remark            string   `description:"备注,长度255位"`
	FileUrls          []string `description:"多个文件附件地址"`
	FileNum           int      `description:"文件份数"`
	AffiliatedCompany string   `description:"归属公司"`
	CompanyId         int      `description:"客户id"`
	StartDate         string   `description:"开始日期."`
	EndDate           string   `description:"结束日期"`
	Money             float64  `description:"合同金额"`
}

// 用印审批编辑请求
type SealApprovalEditReq struct {
	SealId            int      `description:"用印id"`
	ContractId        int      `description:"系统合同id"`
	Use               string   `description:"用印用途，枚举值：'销售合同', '渠道合同', '付款通知函', '招投标', '战略合作协议'；默认：销售合同"`
	CompanyName       string   `description:"客户名称，甲方名称,长度32位"`
	UseCompanyName    string   `description:"实际适用方客户名称，长度32位"`
	CreditCode        string   `description:"社会统一信用代码,长度64位"`
	ServiceType       string   `description:"业务类型，枚举值：'新签合同','续约合同','补充协议'；默认：新签合同"`
	SealType          string   `description:"加盖印章类型，多选，逗号拼接，值：'合同章','公章','法人章'"`
	Remark            string   `description:"备注,长度255位"`
	FileUrls          []string `description:"多个文件附件地址"`
	FileNum           int      `description:"文件份数"`
	AffiliatedCompany string   `description:"归属公司"`
	StartDate         string   `description:"开始日期"`
	EndDate           string   `description:"结束日期"`
	Money             float64  `description:"合同金额"`
}

// 用印审批撤回请求
type SealApprovalCancelReq struct {
	SealId int `description:"用印ID"`
}

// 用印审批删除请求
type SealApprovalDelReq struct {
	SealId int `description:"用印ID"`
}

// 用印审批作废请求
type SealApprovalInvalidReq struct {
	SealId int `description:"用印ID"`
}

// 用印审批通过请求
type SealApplyApprovedReq struct {
	SealId int    `description:"用印id"`
	Remark string `description:"备注字段"`
}

// 用印审批驳回请求
type SealApplyRejectReq struct {
	SealId int    `description:"用印id"`
	Remark string `description:"驳回理由"`
}
