package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/contract"
	"hongze/hz_crm_api/models/seal"
)

// 用印申请列表数据
type SealApprovalListResp struct {
	Paging *paging.PagingItem
	List   []*SealApprovalList `description:"列表数据"`
}

// 用印操作日志列表数据
type SealOperationListResp struct {
	List []*seal.SealOperationRecordList `description:"列表数据"`
}

// 用印审批操作按钮
type SealApprovalOpButton struct {
	Approval   bool `description:"是否有审批权限"`
	Invalid    bool `description:"是否有作废用印权限"`
	Edit       bool `description:"是否有编辑用印权限"`
	CheckEdit  bool `description:"审核状态下是否有编辑用印权限"`
	Cancel     bool `description:"是否有撤回用印权限"`
	UploadFile bool `description:"是否有上传签回文件权限"`
}

type SealApprovalList struct {
	*seal.SealApprovalItem
	OpButton SealApprovalOpButton
}

type SealMoreResp struct {
	*seal.Seal
	FileUrls []string `description:"多个附件"`
}

type SealApprovalDetail struct {
	SealDetail   *SealMoreResp
	FlowNodeList [][]contract.ContractApprovalRecord `description:"审批流"`
	OpButton     SealApprovalOpButton                `description:"操作权限"`
}
