package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

type RoleAdminItemResp struct {
	SysRoleAdminId  int    `description:"绑定ID"`
	AdminId         int    `description:"管理员账号ID"`
	AdminName       string `description:"管理员账号名称"`
	RealName        string `description:"管理员真实姓名"`
	Enabled         int    `description:"账号状态 1:有效，0:禁用"`
	Mobile          string `description:"管理员手机号"`
	DepartmentGroup string `description:"部门/分组"`
	LabelVal        int    `description:"标签:1:超级管理员，2：管理员，3：部门经理，4：组长，5：ficc销售主管"`
	RoleId          int    `description:"角色ID"`
	RoleName        string `description:"角色名称"`
}

type RoleAdminListResp struct {
	List   []*RoleAdminItemResp
	Paging *paging.PagingItem
}

// DepartmentGroupSellersResp 销售列表（根据部门、分组来）
type DepartmentGroupSellersResp struct {
	List []DepartmentGroupSellers
}

type DepartmentGroupSellers struct {
	AdminId      string                   `description:"系统用户id"`
	RealName     string                   `description:"用户真实名称"`
	ChildrenList []DepartmentGroupSellers `description:"销售列表"`
}

// EnglishAuthRoleDetailResp 英文权限角色详情响应体
type EnglishAuthRoleDetailResp struct {
	AdminId      int    `description:"用户ID"`
	AuthName     string `description:"权限名称"`
	RoleTypeCode string `description:"角色类型编码"`
	AuthOk       bool   `description:"是否有权限"`
}
