package models

type XfSendParam struct {
	Common struct {
		AppId string `json:"app_id"`
	} `json:"common"`
	Business struct {
		Aue    string `json:"aue"`
		Sfl    int    `json:"sfl"`
		Auf    string `json:"auf"`
		Vcn    string `json:"vcn"`
		Speed  int    `json:"speed"`
		Volume int    `json:"volume"`
		Pitch  int    `json:"pitch"`
		Bgs    int    `json:"bgs"`
		Tte    string `json:"tte"`
		Reg    string `json:"reg"`
		Rdn    string `json:"rdn"`
	} `json:"business"`
	Data struct {
		Text   string `json:"text"`
		Status int    `json:"status"`
	} `json:"data"`
}

type XfReciveResult struct {
	Code    int
	Message string
	Sid     string
	Data    *struct {
		Audio  string `json:"audio"`
		Ced    string `json:"ced"`
		Status int    `json:"status"`
	} `json:"data"`
}

type AudioReq struct {
	ReportId string
}

type EdbdataImportReq struct {
	FullPath  string
	SysUserId string
}

type EdbdataExportExcelReq struct {
	StartDate  string
	EndDate    string
	Frequency  string
	ClassifyId int
	KeyWord    string
	Mobile     string
}

// 内容转音频后的结构体
type VideoInfo struct {
	VideoUrl         string  `description:"链接"`
	VideoPlaySeconds float64 `description:"时长"`
	VideoSize        string  `description:"大小"`
}
