package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/yb"
)

type CommunityQuestionListResp struct {
	Paging *paging.PagingItem
	List   []*CommunityQuestionItem `description:"列表数据"`
	Count  *CommunityQuestionCount
}

type CommunityQuestionItem struct {
	CommunityQuestionId     int    `description:"问题ID"`
	UserId                  int    `description:"提问用户ID"`
	Mobile                  string `description:"用户手机号"`
	RealName                string `description:"用户名"`
	QuestionContent         string `description:"问题描述"`
	ReplierUserId           int    `description:"回复人的user_id"`
	ReplierAdminId          int    `description:"回复人关联的admin_id"`
	ReplierRealName         string `description:"回复人姓名"`
	ReplierAvatar           string `description:"回复人头像"`
	ResearchGroupFirstId    int    `description:"回复人研究方向一级分组ID"`
	ResearchGroupSecondId   int    `description:"回复人研究方向二级分组ID"`
	ResearchGroupFirstName  string `description:"研究方向一级分组名称"`
	ResearchGroupSecondName string `description:"研究方向二级分组名称"`
	ReplyStatus             int    `description:"状态 1-待分配 2-待回答 3-已回答"`
	MsgSendStatus           int    `description:"消息推送进度 0-待推送 1-已推送回答人 2-已推送提问人"`
	ReplyTime               string `description:"回复时间"`
	CreateTime              string `description:"提问时间"`
	NeedRedistribute        bool   `description:"是否需要重新分配"`
	ClickNum                int    `description:"点击量"`
	UserQaCount             int    `description:"用户提问数"`
	UserHasDetail           bool   `description:"是否有用户详情"`
	StopReason              string `description:"终止原因"`
}

type CommunityQuestionCount struct {
	Free    int `json:"free"`
	Wait    int `json:"wait"`
	Replied int `json:"replied"`
	Total   int `json:"total"`
}

type QuestionClickLogListItem struct {
	UserId         int
	SourceAgent    int
	LastCreateTime string
	ClickNum       int `description:"点击量"`
	RealName       string
	CompanyName    string
	CompanyStatus  string
	CompanyId      int
}

type QuestionCompanyUser struct {
	CommunityQuestionId int    `description:"问题ID"`
	QuestionContent     string `description:"问题描述"`
	UserId              int
	RealName            string
	CompanyName         string
	CompanyStatus       string
	CompanyId           int
	SellerName          string `description:"销售姓名"`
}

type QuestionClickLogListResp struct {
	Paging          *paging.PagingItem
	List            []*QuestionClickLogListItem `description:"列表数据"`
	Count           int
	QuestionContent string `description:"问题描述"`
}

// LikeTeaseListWithQuestionResp 问答点赞吐槽返回数据
type LikeTeaseListWithQuestionResp struct {
	List   []*yb.StatCommunityQuestionLikeTeaseItem
	Paging *paging.PagingItem
}

// LikeTeaseListListResp 问答详情点赞/吐槽用户列表返回数据
type LikeTeaseListListResp struct {
	List   []*yb.LikeTeaseListItem
	Paging *paging.PagingItem
}

// CommunityQuestionCommentResp 社区问答评论列表返回数据
type CommunityQuestionCommentResp struct {
	List   []*yb.YbCommunityQuestionCommentAndQuestion
	Paging *paging.PagingItem
}
