package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

type CommunityVideoListResp struct {
	Paging *paging.PagingItem
	List   []*CommunityVideoItem `description:"列表数据"`
}

type CommunityVideoItem struct {
	CommunityVideoId  int    `description:"问题ID"`
	Title             string `description:"视频标题"`
	VarietyTagId      int    `description:"标签ID"`
	VarietyTagName    string `description:"标签名称"`
	CoverImgUrl       string `description:"封面图地址"`
	VideoUrl          string `description:"视频地址"`
	VideoSeconds      string `description:"视频时长，单位秒"`
	PublishState      int    `description:"发布状态：0-待发布 1-已发布"`
	SendThsState      int    `description:"客群消息推送状态：0-待推送 1-已推送"`
	SendTemplateState int    `description:"模板消息推送状态：0-待推送 1-已推送"`
	CreateTime        string `description:"提问时间"`
	ModifyTime        string `description:"修改时间"`
	ClickNum          int    `description:"点击量"`
}

type VideoPlayLogListItem struct {
	UserId         int
	SourceAgent    int
	//LastCreateTime string
	//ClickNum       int `description:"点击量"`
	RealName       string
	CompanyName    string
	CompanyStatus  string
	CompanyId      int
	CreateTime     string
	StopSeconds    int
}

type VideoPlayLogListResp struct {
	Paging *paging.PagingItem
	List   []*VideoPlayLogListItem `description:"列表数据"`
	Count  int
	Title  string `description:"视频标题"`
}

type CommunityVideoCoverListResp struct {
	Paging *paging.PagingItem
	List   []*CommunityVideoCoverItem `description:"列表数据"`
}

type CommunityVideoCoverItem struct {
	CommunityVideoCoverId int    `description:"封面ID"`
	CoverName             string `description:"封面名称"`
	CoverUrl              string `description:"封面图地址"`
	CreateTime            string `description:"提问时间"`
	ModifyTime            string `description:"修改时间"`
	Type                  int8   `description:"封面类型（1 视频社区，2 路演视频）"`
}
