package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

type LikeReportListItem struct {
	ReportId              int    `description:"报告ID"`
	ReportChapterId       int    `description:"报告章节ID"`
	ClassifyIdFirst       int    `description:"一级分类id"`
	ClassifyNameFirst     string `description:"一级分类名称"`
	LikeNum               int    `description:"点赞数"`
	ModifyTime            string `description:"最新点赞时间"`
	Title                 string `description:"报告标题"`
	ReportChapterTypeName string `description:"品种名称"`
	PublishTime           string `description:"报告发布时间" `
}

type LikeReportListResp struct {
	List   []*LikeReportListItem
	Paging *paging.PagingItem
}

type LikeListItem struct {
	LikeId        uint64 `description:"点赞ID"`
	NickName      string `description:"用户id"`
	RealName      string `description:"用户id"`
	UserId        uint64 `description:"用户id"`
	SourceAgent   int    `description:"留言入口来源，1：小程序，2：pc"`
	ModifyTime    string `description:"修改时间"`
	CompanyName   string `description:"客户名称"`
	CompanyStatus string `description:"客户状态"`
}
type LikeListResp struct {
	List   []*LikeListItem
	Paging *paging.PagingItem
}