package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

type PriceDrivenDetail struct {
	PriceDrivenId int `description:"价格驱动ID"`
	//ChartPermissionId   int    `description:"品种权限ID"`
	VarietyTagId        int    `description:"标签ID"`
	VarietyTagName      string `description:"标签名称"`
	MainVariable        string `description:"关键变量"`
	CoreDrivenType      int    `description:"核心驱动类型 0-多 1-空"`
	CoreDrivenContent   string `description:"核心驱动内容"`
	CoreContent         string `description:"核心内容"`
	LastUpdateAdminId   int    `description:"最后更新人ID"`
	LastUpdateAdminName string `description:"最后更新人名称"`
	SendThsMsgTime      string `description:"推送同花顺客群消息时间"`
	SendTemplateMsgTime string `description:"推送模板消息时间"`
	ThsMsgState         int    `description:"同花顺推送状态：0-未推送 1-已推送"`
	TemplateMsgState    int    `description:"模板消息推送状态：0-未推送 1-已推送"`
	PublishState        int    `description:"发布状态：0-未发布 1-已发布"`
	//AllowSendTemplateMsg bool   `description:"允许推送模板消息"`
	//AllowSendThsMsg      bool   `description:"允许推送同花顺客群消息"`
	CreateTime string `description:"创建时间"`
	ModifyTime string `description:"更新时间"`
}

type ChartPermissionTree struct {
	ClassifyName string            `description:"分类名称"`
	Items        []*PermissionItem `description:"子分类"`
}

type PermissionItem struct {
	PermissionId     int    `description:"权限id"`
	PermissionName   string `description:"权限名称"`
	PriceDrivenState int    `description:"价格驱动状态 0-关闭 1-开启"`
}

// PriceDrivenClickCensusResp 价格驱动点击量统计列表
type PriceDrivenClickCensusResp struct {
	Paging *paging.PagingItem
	List   []*PriceDrivenClickCensusItem `description:"列表数据"`
}

// PriceDrivenClickCensusItem 价格驱动点击量统计
type PriceDrivenClickCensusItem struct {
	PriceDrivenId     int    `description:"最新一篇价格驱动ID"`
	ClassifyId        int    `description:"标签分类ID"`
	ClassifyName      string `description:"标签分类名称"`
	VarietyTagId      int    `description:"标签ID"`
	VarietyTagName    string `description:"标签名称"`
	MainVariable      string `description:"关键变量"`
	CoreDrivenType    int    `description:"核心驱动类型 0-多 1-空"`
	CoreDrivenContent string `description:"核心驱动内容"`
	LastModifyTime    string `description:"上一次更新时间"`
	TotalClickNum     int    `description:"累计点击量"`
	RecentClickNum    int    `description:"最近点击量"`
	RecentClickTime   string `description:"最近点击时间"`
}

// PriceDrivenClickCensusDetailResp 价格驱动点击量统计详情列表
type PriceDrivenClickCensusDetailResp struct {
	Paging    *paging.PagingItem
	PageTotal int                                 `description:"当前页统计总数"`
	List      []*PriceDrivenClickCensusDetailItem `description:"列表数据"`
}

// PriceDrivenVarietyTagClickDetail 价格驱动标签点击统计详情
type PriceDrivenClickCensusDetailItem struct {
	RealName        string `description:"用户姓名"`
	CompanyName     string `description:"公司名称"`
	CompanyStatus   string `description:"公司状态"`
	CountNum        int    `description:"点击量"`
	SourceAgent     int    `description:"来源"`
	RecentClickTime string `description:"最近点击时间"`
}
