package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
	"hongze/hz_crm_api/models/yb"
)

// ProductVisitCountDetailResp 用户阅读统计响应体
type ProductCensusUserVisitCountResp struct {
	List   []*yb.ProductVisitCount
	Paging *paging.PagingItem
}

// ProductCensusUserVisitCountDetailResp 用户阅读统计详情响应体
type ProductCensusUserVisitCountDetailResp struct {
	List   []*ProductCensusUserVisitCountDetail
	Paging *paging.PagingItem
}

// ProductCensusUserVisitCountDetail 用户阅读统计详情
type ProductCensusUserVisitCountDetail struct {
	ProductName string `description:"产品名称: 问答社区/线上路演/语音播报板块名称等"`
	VisitCount  int    `description:"点击量"`
	Title       string `description:"标题"`
	Source      int    `description:"来源：1-小程序 2-PC端"`
	RecentTime  string `description:"最近点击时间"`
}
