package response

import (
	"github.com/rdlucklib/rdluck_tools/paging"
)

type RoadVideoListResp struct {
	Paging *paging.PagingItem
	List   []*RoadVideoItem `description:"列表数据"`
}

type RoadVideoItem struct {
	RoadVideoId          int    `description:"问题ID"`
	Title                string `description:"视频标题"`
	ChartPermissionIds   string `description:"品种权限ID,用英文逗号分隔"`
	ChartPermissionNames string `description:"品种权限名称"`
	CoverImgUrl          string `description:"封面图地址"`
	VideoUrl             string `description:"视频地址"`
	VideoSeconds         string `description:"视频时长，单位秒"`
	PublishState         int    `description:"发布状态：0-待发布 1-已发布"`
	SendThsState         int    `description:"客群消息推送状态：0-待推送 1-已推送"`
	SendTemplateState    int    `description:"模板消息推送状态：0-待推送 1-已推送"`
	AdminId              int    `description:"创建者账号"`
	AdminRealName        string `description:"创建者姓名"`
	CreateTime           string `description:"创建时间"`
	ModifyTime           string `description:"修改时间"`
	ClickNum             int    `description:"点击量"`
	ReportId             int    `description:"关联的报告ID"`
	ReportTitle          string `description:"报告标题"`
}

type RoadVideoCoverListResp struct {
	Paging *paging.PagingItem
	List   []*RoadVideoCoverItem `description:"列表数据"`
}

type RoadVideoCoverItem struct {
	RoadVideoCoverId int    `description:"封面ID"`
	CoverName        string `description:"封面名称"`
	CoverUrl         string `description:"封面图地址"`
	CreateTime       string `description:"提问时间"`
	ModifyTime       string `description:"修改时间"`
	Type             int8   `description:"封面类型（1 视频社区，2 路演视频）"`
}

type RoadPermissionResp struct {
	List []*RoadPermissionItem
}

type RoadPermissionItem struct {
	Id           int
	ClassifyName string
	List         []*RoadPermissionSecondItem
}

type RoadPermissionSecondItem struct {
	ChartPermissionName string
	ChartPermissionID   int
}
