package services

import (
	"fmt"
	"log"
	"strings"

	wkhtml "github.com/SebastiaanKlippert/go-wkhtmltopdf"
)

func HtmlConvertToPdf() {
	fmt.Println("start")
	pdfg, err := wkhtml.NewPDFGenerator()
	if err != nil {
		return
	}

	htmlStr := `<!DOCTYPE html>
<html lang="en">
<head>
    <meta charset="UTF-8">
    <title>Title</title>
</head>
<body>
<div>
    <div style="width: 100%;height: 10px; font-size: 20px;color: red">
        合同编号：FICC20200813-001
    </div>
    <div style="font-size: 16px;margin-top: 20px">
        <h3>
            弘则弥道（上海）投资咨询有限公司
        </h3>

        研究服务合同

        服务购买方（以下称“甲方”）:
        公司地址：
        邮编：
        电话：
        传真：


        服务提供方（以下称“乙方”）: 弘则弥道（上海）投资咨询有限公司
        公司地址：上海市浦东新区世纪大道210号21世纪大厦12层1206室
        邮编：200120
        电话：8621-61645300


        乙方和甲方为本合同的订立双方。根据本合同的条款约定，乙方向甲方提供相应的服务，甲方购买相关服务。

        <p>
            1. 服务内容
            乙方所提供的研究服务（以下简称“服务”）是指甲方所享有的非独占性的以及不可转让的对乙方提供的相关研究产品的使用权。自本合同签署日起，乙方同意向甲方提供的服务具体如下所示：
            1)FICC晨报（全品种，周一至周五）
            2)FICC（全品种）观点汇总周报（剖析宏观环境对商品市场的影响趋势）
            3)商品品种观点汇总双周报（对不同商品板块的深度逻辑梳理）
            4)宏观深度月报（包含：下游草根调研月报，宏观资产配置月报）
            5)电话讨论会（结合双周报和月报的发布，由弘则的研究员主持的线上讨论。通过电话讨论会的形式，弘则的研究团队就宏观或某板块与客户召开行情讨论会，由弘则分析师主持并主讲，参会客户自由参加讨论，充分交流观点。）
            6)宏观数据及商品库存点评（宏观数据点评，以及各工业品库存点评，原油EIA库存点评，甲醇、聚烯烃库存点评）
            7)每日宏观商品复盘（包括宏观日评《每日宏观商品复盘》、《明股实债》；黑色专栏《知白守黑》、能化专栏《化里化外》、有色专栏《有声有色》）
            8)不定期主题沙龙
            9)分析师1V1咨询
            10)研究员路演/培训
            11)弘则研究年度宏观商品策略会
            12)其他咨询服务
        </p>

        <p>
            2. 专题和调研服务
            除本合同第1条约定的服务内容外，乙方可以根据甲方的特定投资需求提供数据支持等专题和调研服务。但是，专题和调研服务不包含在本合同价格中，如甲方有专题或者调研服务需求并且乙方也愿意提供此类服务，双方可以根据专题或调研的服务内容、复杂程度和所需时间就专题服务价格另行达成一致并签署相应的服务协议。
        </p>
        <p>
            3. 合同有效期限
            本合同自双方加盖公章（合同章）签署后生效，有效期限为一年，服务期限为2020年1月1日至2020年12月31日。
        </p>
        <p>
            4. 服务费及支付
            (a)一年服务费总额报价为人民币小写：250000元，大写：贰拾伍万元整（含增值税，税率为6%），为本合同第1条约定的服务内容的全部费用。
            (b)甲方自合同生效日起的十日之内一次性支付一年服务费，乙方收款后为甲方开具合法有效的增值税发票。
            (c)弘则弥道（上海）投资咨询有限公司账户信息如下：
            开户银行：交通银行股份有限公司上海交银大厦支行
            开户名称：弘则弥道（上海）投资咨询有限公司
            银行账号：310066577018800002844
            公司地址：上海市浦东新区世纪大道210号21世纪大厦12层
            财务联系人：孙晨
            联系电话： 8621-61645356
            手 机 ： 17193405562
        </p>
        <p>
            5.责任免除条款
            (a)乙方将以勤勉尽责的原则为甲方提供本合同下的服务，但甲方应当了解由于未来的不确定性和投资的高风险性，本合同下的服务不能完全消除甲方面临的风险，甲方必须自行承担经营管理和投资带来的相关风险。
            (b)乙方研究服务和研究报告中所提供的信息，均根据国际和行业通行准则，并以合法渠道获得，乙方尽可能保证信息的准确、完整，但不对其研究服务成果中所述信息的准确性与完整性作保证，甲方应当自行决定是否采纳乙方提供的信息并自行承担相应的责任。乙方不对甲方因使用乙方提供的信息作出的任何决策承担责任。
        </p>

        <p>
            6. 知识产权
            (a)乙方对其提供的服务，包括但不限于研究信息、报告、期刊和数据，享有完全的知识产权，该知识产权所有权不因为服务的交付而转移给甲方。购买方需同保护其自身知识产权一样来尊重并且依照乙方出示的书面条款去保护乙方所享有的合约的、行业的和法律的权利；这种努力在任何情况下都不应低于合理的程度。甲方同意在其获知任何一种下列情况时立刻书面通知乙方：1）任何未经授权的第三方使用乙方的服务内容
            2）任何第三方声称乙方的服务侵犯了其相应版权，商标或者其他合约的、行业的和法律的权利。
            (b)本合同下的服务仅提供给甲方使用，不得被用于任何非法目的或者任何与本合同所述内容不一致的用途。未得到乙方的书面许可，甲方不得将乙方的研究信息、报告、期刊和数据提供给其它未经乙方授权的使用者。甲方仅能将乙方的研究信息、报告、期刊和数据用作内部使用，未得到乙方的书面许可，不得进行再发行，传播或者发表。
            (c)在合作过程中，未经乙方的书面许可，甲方不得将乙方的研究信息、报告、期刊和数据提供给甲方的客户、子公司、关联公司或控股公司。甲方是使用本研究服务的唯一主体。
            (d)甲方承认本合同下的服务是由乙方及其合作方花费大量时间、人力、资源和金钱运用合适的方法及判断来制作、编辑、修订、挑选和安排的，因此甲方承认服务包含乙方及其合作方有价值的知识产权和商业机密。在服务期间及服务终止之后，甲方同意保护乙方及其合作方对服务内容的所有权。
            (e)甲方不能以任何方式使用乙方的任何商标、商品或服务标记来造成这些名字和商标属于甲方或者和甲方一样的印象，并且甲方承认其对这些名字和商标没有任何所有权和使用权。
            (f)乙方保证其所提供的服务及提供给甲方的研究成果符合现行法律法规的要求，不存在权利瑕疵，否则由乙方承担相应的法律后果。
        </p>
        <p>
            7.违约责任
            甲乙双方应按照本合同约定履行义务，否则构成违约，违约方应向守约方承担违约责任并采取有效补救措施或赔偿由此产生的相应损失。
        </p>
        <p>
            8. 法律管辖
            本合同适用中华人民共和国法律。
        </p>
        <p>
            9. 纠纷解决
            由本合同产生的任何纠纷，双方应友好协商解决，协商不成的任何一方有权提交中国国际经济贸易仲裁委员会上海分会（仲裁中心），按照仲裁申请时中国国际经济贸易仲裁委员会现行有效的仲裁规则进行仲裁。仲裁裁决是终局的，对双方均有约束力。
        </p>
        <p>
            10.其他
            本合同一式两份，甲乙双方各执一份，均具有同等法律效力。
        </p>
        <p>
            甲方: 乙方: 弘则弥道（上海）投资咨询有限公司


            签约日期： 签约日期：
        </p>
    </div>
</div>
</body>
</html>`

	pdfg.AddPage(wkhtml.NewPageReader(strings.NewReader(htmlStr)))

	err = pdfg.Create()
	if err != nil {
		log.Fatal(err)
	}

	//Your Pdf Name
	err = pdfg.WriteFile("./Your_pdfname.pdf")
	if err != nil {
		log.Fatal(err)
	}

	fmt.Println("Done")
	fmt.Println("end")
}
