package statistic_report

// CompanyTodoReportRecordResp 任务todo总统计信息
type CompanyTodoReportRecordResp struct {
	List                           []GroupTodoReportRecord      `description:"系统用户分组信息"`
	CompanyTodoReportRecordNumList []CompanyTodoReportRecordNum `description:"统计次数"`
	DoingExpiredAllNum             int                          `description:"截止日期小于等于当前时间的未完成的总任务数（逾期）"`
	FinishAllNum                   int                          `description:"已完成的总任务数"`
	DoingAllNum                    int                          `description:"进行中的总任务数"`
}

// GroupTodoReportRecord 分组统计信息
type GroupTodoReportRecord struct {
	Item                           []AdminTodoReportRecord      `description:"系统用户信息"`
	GroupId                        int                          `description:"系统用户分组id"`
	Name                           string                       `description:"分组名"`
	CompanyTodoReportRecordNumList []CompanyTodoReportRecordNum `description:"统计次数"`
	DoingExpiredGroupNum           int                          `description:"截止日期小于等于当前时间的未完成的组内合计任务数（逾期）"`
	DoingExpiredGroupCompanyIds    string                       `description:"截止日期小于等于当前时间的未完成的组内合计任务数相关的客户ID（逾期）"`
	FinishNum                      int                          `description:"已完成的任务数"`
	FinishCompanyIds               string                       `description:"已完成任务数相关的客户ID"`
	DoingExpiredAllNum             int                          `description:"截止日期小于等于当前时间的未完成的总任务数"`
	FinishAllNum                   int                          `description:"已完成的总任务数"`
	DoingNum                       int                          `description:"进行中的任务数"`
	DoingCompanyIds                string                       `description:"进行中任务数相关的客户ID"`
}

// AdminTodoReportRecord 系统用户统计信息
type AdminTodoReportRecord struct {
	Name                           string                       `description:"系统用户名"`
	AdminId                        int                          `description:"系统用户id"`
	AdminCompanyIds                string                       `description:"销售所有的试用客户"`
	CompanyTodoReportRecordNumList []CompanyTodoReportRecordNum `description:"统计次数"`
	DoingExpiredNum                int                          `description:"截止日期小于等于当前时间的未完成的任务数（逾期）"`
	DoingExpiredCompanyIds         string                       `description:"截止日期小于等于当前时间的未完成任务数相关的客户ID（逾期）"`
	FinishNum                      int                          `description:"已完成的任务数"`
	FinishCompanyIds               string                       `description:"已完成任务数相关的客户ID"`
	DoingNum                       int                          `description:"进行中的任务数"`
	DoingCompanyIds                string                       `description:"进行中任务数相关的客户ID"`
}

// CompanyTodoReportRecordNum 系统用户统计信息
type CompanyTodoReportRecordNum struct {
	TryOutAddMap       int    `description:"试用新增客户数"`
	TryOutAddIdMap     string `description:"试用新增客户ids"`
	TryOutApproveMap   int    `description:"试用完成客户数"`
	TryOutApproveIdMap string `description:"试用完成客户ids"`
	FormalAddMap       int    `description:"正式新增客户数"`
	FormalAddIdMap     string `description:"正式新增客户ids"`
	FormalApproveMap   int    `description:"正式完成客户数"`
	FormalApproveIdMap string `description:"正式完成客户ids"`

	AddMap       int    `description:"新增to do客户数"`
	AddIdMap     string `description:"新增to do客户ids"`
	ApproveMap   int    `description:"完成to do客户数"`
	ApproveIdMap string `description:"完成to do客户ids"`

	StartDate string `description:"开始日期"`
	EndDate   string `description:"结束日期"`
}
