package routers

import (
	beego "github.com/beego/beego/v2/server/web"
	"github.com/beego/beego/v2/server/web/context/param"
)

func init() {

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/article/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/article/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "FirstAdd",
            Router: `/article/firstadd`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/article/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "FirstPreservation",
            Router: `/article/preservation`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "Unpublish",
            Router: `/article/unpublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "ArticleCode",
            Router: `/articleCode`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminArticleController"],
        beego.ControllerComments{
            Method: "GetPVAndUv",
            Router: `/getPVAndUv`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/advisory:AdminUserController"],
        beego.ControllerComments{
            Method: "GetMyFllow",
            Router: `/getmyfllow`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chat`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicDelete",
            Router: `/topic/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicDetail",
            Router: `/topic/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicEdit",
            Router: `/topic/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/ai:AiController"],
        beego.ControllerComments{
            Method: "TopicList",
            Router: `/topic/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApplyAdd",
            Router: `/apply/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApplyApprove",
            Router: `/apply/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "Back",
            Router: `/apply/back`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "Close",
            Router: `/apply/close`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/apply/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApplyDetail",
            Router: `/apply/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApplyEdit",
            Router: `/apply/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApplyList",
            Router: `/apply/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "ApproveList",
            Router: `/approve/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/business_trip:BusinessTrip"],
        beego.ControllerComments{
            Method: "BusinessTripCalendar",
            Router: `/calendar`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "Apply",
            Router: `/approval/apply`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "Approved",
            Router: `/approval/approved`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "CancelApply",
            Router: `/approval/cancelApply`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/approval/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/approval/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractApprovalController"],
        beego.ControllerComments{
            Method: "Reject",
            Router: `/approval/reject`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "AddContract",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "BusinessContractCompanyList",
            Router: `/business_contract/company_name/list/`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "BusinessContractListByCompanyName",
            Router: `/business_contract/list/`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "DetailMerge",
            Router: `/detail/merge`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "DownLoadTmpContract",
            Router: `/downLoad/tmpContract`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "EditContract",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "GetListBySeal",
            Router: `/getListBySeal`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "Invalid",
            Router: `/invalid`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "OperationList",
            Router: `/operation/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "GetPayChannel",
            Router: `/pay_channel/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "PreviewByContractId",
            Router: `/previewByContractId`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "GetServiceTemplateList",
            Router: `/service/template/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "GetContractTemplateList",
            Router: `/template/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "UpdateFile",
            Router: `/update_file`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "UploadCheckBackFile",
            Router: `/upload_check_back_file`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/contract:ContractController"],
        beego.ControllerComments{
            Method: "UploadRescindFile",
            Router: `/upload_rescind_file`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/activity/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/activity/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "ChartPermissionListAct",
            Router: `/activity/chartPermission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "CompanySearch",
            Router: `/activity/companySearch`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "List",
            Router: `/activity/customerTypelist`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "DeadlineSet",
            Router: `/activity/deadlineSet`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/activity/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/activity/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "ImgToText",
            Router: `/activity/imgToText`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "ActivityList",
            Router: `/activity/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "PointsSet",
            Router: `/activity/pointsSet`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityCoAntroller"],
        beego.ControllerComments{
            Method: "TopeChange",
            Router: `/activity/tope_change`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"],
        beego.ControllerComments{
            Method: "CompanyList",
            Router: `/activityLoss/company/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"],
        beego.ControllerComments{
            Method: "MeetList",
            Router: `/activityLoss/meet/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityLossCoAntroller"],
        beego.ControllerComments{
            Method: "UserList",
            Router: `/activityLoss/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/activityMeet/addRemarks`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "AddStopTime",
            Router: `/activityMeet/addStopTime`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "AppointmentList",
            Router: `/activityMeet/appointmentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "AttendanceDetail",
            Router: `/activityMeet/attendanceDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "BreakAppointment",
            Router: `/activityMeet/breakAppointment`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "BreakAppointmentDetail",
            Router: `/activityMeet/breakAppointmentDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "CompanyCoount",
            Router: `/activityMeet/companyCoount`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "CompanyHisory",
            Router: `/activityMeet/companyHistory`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "HistoryList",
            Router: `/activityMeet/history/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "Import",
            Router: `/activityMeet/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "ImportYidongConduct",
            Router: `/activityMeet/importYidong`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "MeetList",
            Router: `/activityMeet/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "MatchingByHand",
            Router: `/activityMeet/matchingByHand`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "MatchingList",
            Router: `/activityMeet/matchingList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "MeetingDo",
            Router: `/activityMeet/meetingDo`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "SignupFailExport",
            Router: `/activityMeet/meetingExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "OfflineListDetail",
            Router: `/activityMeet/offlineListDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "OfflineMeetingList",
            Router: `/activityMeet/offlineMeetingList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "RemarkList",
            Router: `/activityMeet/remark/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "SellerName",
            Router: `/activityMeet/sellerNameList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityMeetCoAntroller"],
        beego.ControllerComments{
            Method: "SignUpRestrict",
            Router: `/activityMeet/signUpRestrictUid`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AddSignuUser",
            Router: `/activitySignup/addSignuUser`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AddSignuUserOptType",
            Router: `/activitySignup/addSignuUserOptType`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AddUser",
            Router: `/activitySignup/addUser`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AddSummaryUser",
            Router: `/activitySignup/appointment/addSummaryUser`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SummaryCancel",
            Router: `/activitySignup/appointment/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SummaryList",
            Router: `/activitySignup/appointment/summaryList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AppointmentList",
            Router: `/activitySignup/appointmentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AskList",
            Router: `/activitySignup/askList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "AskListExport",
            Router: `/activitySignup/askListExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "CallExport",
            Router: `/activitySignup/callExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "FailSignupList",
            Router: `/activitySignup/callFailSignupList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "CallSignupEdit",
            Router: `/activitySignup/callSignupEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SignupCancel",
            Router: `/activitySignup/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SignupList",
            Router: `/activitySignup/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "OutboundMobileEdit",
            Router: `/activitySignup/outboundMobileEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "ReminderCancel",
            Router: `/activitySignup/reminder/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "ReminderList",
            Router: `/activitySignup/reminder/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SalonFailSignupList",
            Router: `/activitySignup/salonFailSignupList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SalonSignupEdit",
            Router: `/activitySignup/salonSignupEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SignupDetail",
            Router: `/activitySignup/signupDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SignupFailExport",
            Router: `/activitySignup/signupFailExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "TempMsg",
            Router: `/activitySignup/tempMsg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SendGroupList",
            Router: `/activitySignup/tempMsg/sendGroupList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "OutboundPersonnelList",
            Router: `/activitySignup/userList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySignupCoAntroller"],
        beego.ControllerComments{
            Method: "SpecialExport",
            Router: `/special/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "Offline",
            Router: `/special/Offline`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/special/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/special/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/special/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/special/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "InterestedList",
            Router: `/special/interested/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "ActivityList",
            Router: `/special/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "ActivitySignupList",
            Router: `/special/signup/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialCoAntroller"],
        beego.ControllerComments{
            Method: "TripPreserveAndPublish",
            Router: `/special/trip/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "AddUser",
            Router: `/special/trip/addUser`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "TripCancel",
            Router: `/special/trip/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "MeetDetial",
            Router: `/special/trip/meetDetial`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "MeetingDo",
            Router: `/special/trip/meetingDo`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "OutboundMobileEdit",
            Router: `/special/trip/outboundMobileEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "TempMsg",
            Router: `/special/trip/tempMsg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "SendGroupList",
            Router: `/special/trip/tempMsg/sendGroupList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivitySpecialTripCoAntroller"],
        beego.ControllerComments{
            Method: "TripList",
            Router: `/special/tripList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/activityType/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"],
        beego.ControllerComments{
            Method: "List",
            Router: `/activityType/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"],
        beego.ControllerComments{
            Method: "ListSearch",
            Router: `/activityType/listSearch`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"],
        beego.ControllerComments{
            Method: "MeetType",
            Router: `/activityType/meetType`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityTypeCoAntroller"],
        beego.ControllerComments{
            Method: "ArticleTypeList",
            Router: `/summaryManage/articleType/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/activityVideo/commentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "CommentListExport",
            Router: `/activityVideo/commnetListExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "VideoDeatil",
            Router: `/activityVideo/deatil`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "ActivityVideoList",
            Router: `/activityVideo/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "VideoAndVoice",
            Router: `/activityVideo/video_and_voice/img`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "VoiceAndVideoCommentList",
            Router: `/activity_voice_and_video/commentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ActivityVideoCoAntroller"],
        beego.ControllerComments{
            Method: "ActivityVoiceAndVideoList",
            Router: `/activity_voice_and_video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AdviceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AdviceController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/advice/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ApplyRecordController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/apply/record/deal`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ApplyRecordController"],
        beego.ControllerComments{
            Method: "ListSysRole",
            Router: `/apply/record/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "CollectionList",
            Router: `/askserie_video/collection_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/askserie_video/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "HistoryList",
            Router: `/askserie_video/history_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/askserie_video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/askserie_video/preserveAndEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:AskserieVideoController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/askserie_video/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/banner/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "PvExport",
            Router: `/banner/PvExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/banner/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "ImgList",
            Router: `/banner/img/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "List",
            Router: `/banner/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/banner/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:BannerCoAntroller"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/banner/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"],
        beego.ControllerComments{
            Method: "CompanyContractList",
            Router: `/allocation/company_contract_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"],
        beego.ControllerComments{
            Method: "CompanyContracDetail",
            Router: `/allocation/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"],
        beego.ControllerComments{
            Method: "CompanyContractStatistics",
            Router: `/allocation/statistics`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ContractAllocationController"],
        beego.ControllerComments{
            Method: "CompanyContracUpdate",
            Router: `/allocation/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "CompanySearchList",
            Router: `/enterScore/company/searchlist`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreDelete",
            Router: `/enterScore/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreDetail",
            Router: `/enterScore/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreList",
            Router: `/enterScore/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreRankingOverview",
            Router: `/enterScore/rankingOverview`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreScoreOverview",
            Router: `/enterScore/scoreOverview`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:EnterScoreController"],
        beego.ControllerComments{
            Method: "EnterScoreUpdate",
            Router: `/enterScore/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "PvExport",
            Router: `/gushouTimeLine/PvExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "PublishCancleReport",
            Router: `/gushouTimeLine/all/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/gushouTimeLine/delete`,
            AllowHTTPMethods: []string{"POST"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/gushouTimeLine/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/gushouTimeLine/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/gushouTimeLine/preserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:GushouTimeLineController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/gushouTimeLine/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"],
        beego.ControllerComments{
            Method: "IndustrialAnalystAdd",
            Router: `/industrialAnalyst/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"],
        beego.ControllerComments{
            Method: "IndustrialAnalystDelete",
            Router: `/industrialAnalyst/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"],
        beego.ControllerComments{
            Method: "IndustrialAnalystEdit",
            Router: `/industrialAnalyst/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialAnalystController"],
        beego.ControllerComments{
            Method: "IndustrialAnalystlist",
            Router: `/industrialAnalyst/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ChartPermissionListActivitySpecial",
            Router: `/chartPermission/activitySpecial`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ChartPermissionList",
            Router: `/chartPermission/first`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ChartPermissionListIco",
            Router: `/chartPermission/firstHaveIco`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ChartPermissionFirstProduct",
            Router: `/chartPermission/firstProduct`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ListIndustrial",
            Router: `/chartPermission/listIndustrial`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "NoTacticsChartPermissionList",
            Router: `/chartPermission/noTacticsfirst`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "NoTacticsChartPermissionOtherList",
            Router: `/chartPermission/noTacticsfirstOther`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementAdd",
            Router: `/industrialManagement/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementDelete",
            Router: `/industrialManagement/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/industrialManagement/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementEdit",
            Router: `/industrialManagement/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "ChartPermissionExport",
            Router: `/industrialManagement/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementDetail",
            Router: `/industrialManagement/industrialManagementDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementlist",
            Router: `/industrialManagement/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementlistByName",
            Router: `/industrialManagement/listByName`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustryMove",
            Router: `/industrialManagement/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialManagementController"],
        beego.ControllerComments{
            Method: "IndustrialSearch",
            Router: `/industrialManagement/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialAndSubjectSearch",
            Router: `/industrialAndSubject/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectAdd",
            Router: `/industrialSubject/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "CountDetail",
            Router: `/industrialSubject/countDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectDelete",
            Router: `/industrialSubject/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectEdit",
            Router: `/industrialSubject/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectlist",
            Router: `/industrialSubject/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectByName",
            Router: `/industrialSubject/listByName`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectlistIds",
            Router: `/industrialSubject/listIds`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "IndustrialSubjectSearch",
            Router: `/industrialSubject/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "SearchInfo",
            Router: `/industrialSubject/searchInfo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "ReportArticleClassification",
            Router: `/reportArticle/classification`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "CompanyCount",
            Router: `/reportArticle/companyCount`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "CompanyHistory",
            Router: `/reportArticle/companyHistory`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "CompanyOtherHistory",
            Router: `/reportArticle/companyOtherHistory`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/reportArticle/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "ReportArticleFilter",
            Router: `/reportArticle/filter`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "GetMatchTypeNameByReportId",
            Router: `/reportArticle/getMatchTypeName`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "ShowButton",
            Router: `/reportArticle/showButton`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "UpdateMatchTypeName",
            Router: `/reportArticle/updateMatchTypeName`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustrialSubjectController"],
        beego.ControllerComments{
            Method: "ReportMappingAdd",
            Router: `/reportMapping/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"],
        beego.ControllerComments{
            Method: "IndustryMapAdd",
            Router: `/industry/map/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"],
        beego.ControllerComments{
            Method: "IndustryMapDelete",
            Router: `/industry/map/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"],
        beego.ControllerComments{
            Method: "IndustryMapEdit",
            Router: `/industry/map/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:IndustryMapController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/industry/map/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:InterviewApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:InterviewApplyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/interview/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:InterviewApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:InterviewApplyController"],
        beego.ControllerComments{
            Method: "InterviewApplyCancel",
            Router: `/interview/status/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/microRoadshow/commentList/video`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "VoiceCommentList",
            Router: `/microRoadshow/commentList/voice`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "CommentListExport",
            Router: `/microRoadshow/commentListExport/video`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "VoiceCommentListExport",
            Router: `/microRoadshow/commentListExport/voice`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/microRoadshow/video/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "Deatil",
            Router: `/microRoadshow/video/deatil`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/microRoadshow/video/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/microRoadshow/video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "PublishCancel",
            Router: `/microRoadshow/video/publish`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "VoiceDeatil",
            Router: `/microRoadshow/voice/deatil`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MicroRoadshowController"],
        beego.ControllerComments{
            Method: "VoiceList",
            Router: `/microRoadshow/voice/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/minutesSummary/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/minutesSummary/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/minutesSummary/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/minutesSummary/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/minutesSummary/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "MinutesSummarySendMail",
            Router: `/minutesSummary/sendMail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MinutesSummaryController"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/minutesSummary/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/morningMeeting/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/morningMeeting/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/morningMeeting/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "ListPv",
            Router: `/morningMeeting/list_pv`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/morningMeeting/preserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/morningMeeting/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:MorningMeetingController"],
        beego.ControllerComments{
            Method: "PublishCancleReport",
            Router: `/morningMeeting/publish/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:OrderController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:OrderController"],
        beego.ControllerComments{
            Method: "OrderList",
            Router: `/order/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:OrderController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:OrderController"],
        beego.ControllerComments{
            Method: "OrderRefundList",
            Router: `/order/refund/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "PvExport",
            Router: `/productInterior/PvExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/productInterior/delete`,
            AllowHTTPMethods: []string{"POST"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/productInterior/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/productInterior/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/productInterior/preserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/productInterior/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ProductInteriorController"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/productInterior/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/questionnaire/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/questionnaire/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/questionnaire/preserveAndEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "VoteDetail",
            Router: `/questionnaire/vote_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "VoteList",
            Router: `/questionnaire/vote_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:QuestionnaireController"],
        beego.ControllerComments{
            Method: "VoteOther",
            Router: `/questionnaire/vote_other`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "BillList",
            Router: `/rai_serve/bill_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "ChcckPermissionName",
            Router: `/rai_serve/chcck_PermissionName`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "CoverageRate",
            Router: `/rai_serve/coverage_rate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "List",
            Router: `/rai_serve/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "AddRemark",
            Router: `/rai_serve/remark/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "RemarkList",
            Router: `/rai_serve/remark/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "SearchTag",
            Router: `/rai_serve/search_tag`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "SearchTagCalendar",
            Router: `/rai_serve/search_tag_by_calendar`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "TypeList",
            Router: `/rai_serve/type_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RaiServeCoAntroller"],
        beego.ControllerComments{
            Method: "UserFeedbackList",
            Router: `/user_feedback/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "ExportList",
            Router: `/company/exportList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/reportArticle/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/reportArticle/commentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "CommentListExport",
            Router: `/reportArticle/commnetListExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "DepartmentList",
            Router: `/reportArticle/departmentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/reportArticle/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "ReportArticleList",
            Router: `/reportArticle/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "CygxReportMappingMatchTypeList",
            Router: `/reportMappingMatchTypeRep/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportArticleController"],
        beego.ControllerComments{
            Method: "CygxReportMappingist",
            Router: `/reportMappingist/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/reportSelection/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/reportSelection/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "AddThirdName",
            Router: `/reportSelection/add/third_name`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "ArticleHistoryExport",
            Router: `/reportSelection/articleHistoryExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/reportSelection/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/reportSelection/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "DetailTemplate",
            Router: `/reportSelection/detailTemplate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "GetArticle",
            Router: `/reportSelection/getArticle`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "History",
            Router: `/reportSelection/history`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/reportSelection/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "ListPeriods",
            Router: `/reportSelection/listPeriods`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "RarryList",
            Router: `/reportSelection/tarryList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ReportSelectionController"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/reportSelection/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/researchSummary/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/researchSummary/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/researchSummary/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/researchSummary/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "DetailTemplate",
            Router: `/researchSummary/detailTemplate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/researchSummary/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "ResearchSummarySendMail",
            Router: `/researchSummary/sendMail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:ResearchSummaryController"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/researchSummary/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/roadshowEssence/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/roadshowEssence/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/roadshowEssence/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/roadshowEssence/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/roadshowEssence/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:RoadshowEssenceController"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/roadshowEssence/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"],
        beego.ControllerComments{
            Method: "CnaDownload",
            Router: `/hostKeyword/canDownload`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"],
        beego.ControllerComments{
            Method: "HostKeywordDownload",
            Router: `/hostKeyword/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SearchKeywordController"],
        beego.ControllerComments{
            Method: "HostKeywordList",
            Router: `/hostKeyword/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/summaryManage/PreserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "PublishAndCancel",
            Router: `/summaryManage/PublishAndCancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "ArticleCollection",
            Router: `/summaryManage/articleCollection`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "ArticleHistoryExport",
            Router: `/summaryManage/articleHistoryExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "ArticleTypeListAdd",
            Router: `/summaryManage/articleType/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "AskList",
            Router: `/summaryManage/askList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "AskListExport",
            Router: `/summaryManage/askListExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/summaryManage/commentList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "CommentListExport",
            Router: `/summaryManage/commentListExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/summaryManage/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "FepartmentfollowList",
            Router: `/summaryManage/department/followList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/summaryManage/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "EditFastSearch",
            Router: `/summaryManage/editFastSearchKeWord`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "FastSearch",
            Router: `/summaryManage/fastSearchKeWord`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "SummaryManageList",
            Router: `/summaryManage/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "Sustainable",
            Router: `/summaryManage/sustainableDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "EditSustainable",
            Router: `/summaryManage/sustainableEdit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "TopeChange",
            Router: `/summaryManage/top_change`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:SummaryManage"],
        beego.ControllerComments{
            Method: "VisibleRange",
            Router: `/summaryManage/visibleRange`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "PvExport",
            Router: `/tacticsTimeLine/PvExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "PublishCancleReport",
            Router: `/tacticsTimeLine/all/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/tacticsTimeLine/delete`,
            AllowHTTPMethods: []string{"POST"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/tacticsTimeLine/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/tacticsTimeLine/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "PreserveAndPublish",
            Router: `/tacticsTimeLine/preserveAndPublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TacticsTimeLineController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/tacticsTimeLine/publishAndcancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "PvExport",
            Router: `/tag/PvExport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagEnable",
            Router: `/tag/enable`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagHotActivityList",
            Router: `/tag/hot_activity/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagHotActivityUpdate",
            Router: `/tag/hot_activity/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "IndustrialManagementlistByName",
            Router: `/tag/industrialManagement/listByName`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagList",
            Router: `/tag/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagCustomizeList",
            Router: `/tag/list/custom`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "MoveTag",
            Router: `/tag/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "TagSave",
            Router: `/tag/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:TagManagementController"],
        beego.ControllerComments{
            Method: "SubCategoryNameList",
            Router: `/tag/subCategoryName/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserAdminShareHistoryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserAdminShareHistoryController"],
        beego.ControllerComments{
            Method: "OrderList",
            Router: `/mfyx/admin/share/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "OrderRefund",
            Router: `/order/refund`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "OrderRefundRevoke",
            Router: `/order/refund_revoke`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/user/addRemarks`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "CompanyExportInteraction",
            Router: `/user/company/export/interaction`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "CompanyTableDetail",
            Router: `/user/company/interaction/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "CompanyList",
            Router: `/user/company/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "CompanyTableList",
            Router: `/user/company/table/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "CompanyExportInteractionList",
            Router: `/user/companyList/export/interaction`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "ExportInteraction",
            Router: `/user/export/interaction`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "TableDetail",
            Router: `/user/interaction/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "InteractionRelevant",
            Router: `/user/interaction/relevant`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "InteractionNum",
            Router: `/user/interactionNum`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "LabelDetail",
            Router: `/user/label/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "RemarkList",
            Router: `/user/remark/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "UserRemind",
            Router: `/user/remind`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "StatusTable",
            Router: `/user/status/table`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "TableCompanyList",
            Router: `/user/table/companyList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserController"],
        beego.ControllerComments{
            Method: "TableList",
            Router: `/user/table/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserFeedbackController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserFeedbackController"],
        beego.ControllerComments{
            Method: "UserFeedbackAdd",
            Router: `/user_feedback/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserFeedbackController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserFeedbackController"],
        beego.ControllerComments{
            Method: "UserFeedbackDel",
            Router: `/user_feedback/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/use_rai_label/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"],
        beego.ControllerComments{
            Method: "Delte",
            Router: `/use_rai_label/delte`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/use_rai_label/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:UserRaiLabelController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/use_rai_label/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "ApprovalLogList",
            Router: `/yanxuan_special/approval_log_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/yanxuan_special/author/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "AuthorEnable",
            Router: `/yanxuan_special/author/enable`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "AuthorList",
            Router: `/yanxuan_special/author/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "AuthorSearch",
            Router: `/yanxuan_special/author/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "AuthorUpdate",
            Router: `/yanxuan_special/author/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "Enable",
            Router: `/yanxuan_special/enable`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/yanxuan_special/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "ListPv",
            Router: `/yanxuan_special/list_pv`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "ShowButton",
            Router: `/yanxuan_special/show_button`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "SpecialAuthorFansList",
            Router: `/yanxuan_special/special_author_fans_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/cygx:YanxuanSpecialController"],
        beego.ControllerComments{
            Method: "SpecialCollectList",
            Router: `/yanxuan_special/special_collect/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Newest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/chart_info/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/correlation:CorrelationChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoAdd",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoBase64Upload",
            Router: `/chart_info/base64Upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "CopyChartInfo",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoDetail",
            Router: `/chart_info/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoSearch",
            Router: `/chart_info/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartEnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoImageSet",
            Router: `/chart_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartList",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoMove",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoNewest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewBarChartInfo",
            Router: `/chart_info/preview_bar`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ProfitChartInfoAdd",
            Router: `/chart_info/profit/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ProfitChartInfoEdit",
            Router: `/chart_info/profit/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewProfitChartInfo",
            Router: `/chart_info/profit/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoRefresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSave",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoDataList",
            Router: `/edb_info/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoGroupList",
            Router: `/edb_info/group/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbInfoList",
            Router: `/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/future_good:FutureGoodEdbInfoController"],
        beego.ControllerComments{
            Method: "FutureGoodEdbExchangeList",
            Router: `/exchange/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Preview",
            Router: `/chart_info/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_equation:LineEquationChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/multiple_graph/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyList",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveChart",
            Router: `/chart/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "DetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "EnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chart_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "SearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSave",
            Router: `/config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveEdb",
            Router: `/edb/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreview",
            Router: `/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/line_feature:LineFeaturesChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreviewCurve",
            Router: `/preview_cure`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/variety/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Analysis",
            Router: `/variety/analysis`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataExport",
            Router: `/variety/data/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/variety/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/variety/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/variety/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "AddToEdb",
            Router: `/variety/edb/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataList",
            Router: `/variety/edb/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbDataListV2",
            Router: `/variety/edb/data/list/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbInfoDataSeasonal",
            Router: `/variety/edb/data/seasonal`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbInfoDataTb",
            Router: `/variety/edb/data/tb`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EdbList",
            Router: `/variety/edb/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/variety/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/variety/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "AddPlant",
            Router: `/variety/plant/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "CopyPlant",
            Router: `/variety/plant/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "DeletePlant",
            Router: `/variety/plant/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "EditPlant",
            Router: `/variety/plant/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "PlantList",
            Router: `/variety/plant/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage/supply_analysis:VarietyController"],
        beego.ControllerComments{
            Method: "ModifyProductionDay",
            Router: `/variety/production_day/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"],
        beego.ControllerComments{
            Method: "VisitorsCovidLastDate",
            Router: `/visitors_covid/last_date`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromChangesVisitorsCovidController"],
        beego.ControllerComments{
            Method: "VisitorsCovidList",
            Router: `/visitors_covid/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/base_from_national_statistics/classify_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "DbList",
            Router: `/base_from_national_statistics/db_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "IndexDetail",
            Router: `/base_from_national_statistics/index_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:BaseFromNationalStatisticsController"],
        beego.ControllerComments{
            Method: "IndexList",
            Router: `/base_from_national_statistics/index_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "AddChartClassify",
            Router: `/chart_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyChartListV2",
            Router: `/chart_classify/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassify",
            Router: `/chart_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "DeleteChartClassifyCheck",
            Router: `/chart_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "EditChartClassify",
            Router: `/chart_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyItems",
            Router: `/chart_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyListV2",
            Router: `/chart_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ChartClassifyMove",
            Router: `/chart_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "AddManualClassify",
            Router: `/manual/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ManualClassifyDel",
            Router: `/manual/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartClassifyController"],
        beego.ControllerComments{
            Method: "ManualClassifyEdit",
            Router: `/manual/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoAdd",
            Router: `/chart_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoBase64Upload",
            Router: `/chart_info/base64Upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CommonChartInfoDetailFromUniqueCode",
            Router: `/chart_info/common/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CopyChartInfo",
            Router: `/chart_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetail",
            Router: `/chart_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoDetailFromUniqueCode",
            Router: `/chart_info/detail/from_unique_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoDetail",
            Router: `/chart_info/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdbInfoSearch",
            Router: `/chart_info/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoEdit",
            Router: `/chart_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartEnInfoEdit",
            Router: `/chart_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoImageSet",
            Router: `/chart_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoMove",
            Router: `/chart_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoNewest",
            Router: `/chart_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewSectionScatterChartInfo",
            Router: `/chart_info/preview/time_section`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "PreviewBarChartInfo",
            Router: `/chart_info/preview_bar`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSave",
            Router: `/chart_info/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearch",
            Router: `/chart_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoSearchByEs",
            Router: `/chart_info/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "SaveAdjustEdbInfo",
            Router: `/edb_info/adjust/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchEdit",
            Router: `/edb_info/calculate/batch/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchReset",
            Router: `/edb_info/calculate/batch/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchSave",
            Router: `/edb_info/calculate/batch/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "BatchCalculateBatchSave",
            Router: `/edb_info/calculate/batch/save/batch`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateDetail",
            Router: `/edb_info/calculate/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateEdit",
            Router: `/edb_info/calculate/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateMapping",
            Router: `/edb_info/calculate/mapping`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "CalculateSave",
            Router: `/edb_info/calculate/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoData",
            Router: `/edb_info/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDataSeasonal",
            Router: `/edb_info/data/seasonal`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDataTb",
            Router: `/edb_info/data/tb`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "AddPythonEdb",
            Router: `/edb_info/python/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "GetPythonEdbCode",
            Router: `/edb_info/python/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EditPythonEdb",
            Router: `/edb_info/python/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "ExecPythonCode",
            Router: `/edb_info/python/exec`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoReplace",
            Router: `/edb_info/replace`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveChart",
            Router: `/multiple_graph/chart/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "GetMultipleGraphConfig",
            Router: `/multiple_graph/config/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSave",
            Router: `/multiple_graph/config/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphConfigSaveEdb",
            Router: `/multiple_graph/edb/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreview",
            Router: `/multiple_graph/preview`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ChartInfoController"],
        beego.ControllerComments{
            Method: "MultipleGraphPreviewCurve",
            Router: `/multiple_graph/preview_cure`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddEdbClassify",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteEdbClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteEdbClassifyCheck",
            Router: `/classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyEdbInfoList",
            Router: `/classify/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditEdbClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "Items",
            Router: `/classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ItemsV2",
            Router: `/classify/items/v2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "ListV2",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EdbClassifyMove",
            Router: `/edb_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddMysteelChemical",
            Router: `/mysteel_chemical/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "AddMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MoveMysteelChemicalClassify",
            Router: `/mysteel_chemical/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteMysteelChemical",
            Router: `/mysteel_chemical/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "EditMysteelChemical",
            Router: `/mysteel_chemical/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MysteelChemicalExport",
            Router: `/mysteel_chemical/export/dataList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbClassifyController"],
        beego.ControllerComments{
            Method: "MoveMysteelChemical",
            Router: `/mysteel_chemical/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoClassify",
            Router: `/baiinfo/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddBaiinfoClassify",
            Router: `/baiinfo/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteBaiinfoClassify",
            Router: `/baiinfo/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditBaiinfoClassify",
            Router: `/baiinfo/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveBaiinfoClassify",
            Router: `/baiinfo/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoClassifyName",
            Router: `/baiinfo/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoData",
            Router: `/baiinfo/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteBaiinfoData",
            Router: `/baiinfo/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditBaiinfo",
            Router: `/baiinfo/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoFrequency",
            Router: `/baiinfo/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveBaiinfoData",
            Router: `/baiinfo/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetBaiinfoData",
            Router: `/baiinfo/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoSearchList",
            Router: `/baiinfo/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BaiinfoSingleData",
            Router: `/baiinfo/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BatchChartInfoRefresh",
            Router: `/chart_info/batch_refresh`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ChartInfoRefresh",
            Router: `/chart_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeCountryList",
            Router: `/com_trade/country/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeDataList",
            Router: `/com_trade/data/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ComTradeList",
            Router: `/com_trade/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveEdbChartUser",
            Router: `/edb_chart/change_user`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartClassifyList",
            Router: `/edb_chart/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveEdbChartList",
            Router: `/edb_chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "QueryEdbDataTable",
            Router: `/edb_data/table/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoAdd",
            Router: `/edb_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GetEdbDateData",
            Router: `/edb_info/date_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoDetail",
            Router: `/edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoEdit",
            Router: `/edb_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbEnInfoEdit",
            Router: `/edb_info/en/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoFilter",
            Router: `/edb_info/filter`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoFilterByEs",
            Router: `/edb_info/filter_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AllEdbInfoByEs",
            Router: `/edb_info/filter_by_es/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SetEdbDataInsertConfig",
            Router: `/edb_info/insert_config/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoList",
            Router: `/edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoMove",
            Router: `/edb_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoNewest",
            Router: `/edb_info/newest`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoRefresh",
            Router: `/edb_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoAllRefresh",
            Router: `/edb_info/refresh/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RelationChartList",
            Router: `/edb_info/relation/chart_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "RelationEdbList",
            Router: `/edb_info/relation/edbinfo_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoReplaceCheck",
            Router: `/edb_info/replace/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoSearch",
            Router: `/edb_info/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "TraceEdbInfo",
            Router: `/edb_info/trace`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdates",
            Router: `/edb_info/updates`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesCheck",
            Router: `/edb_info/updates/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesList",
            Router: `/edb_info/updates/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbInfoUpdatesStatistical",
            Router: `/edb_info/updates/statistical`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "BatchAddNoPermissionAdmin",
            Router: `/edb_no_permission/batch_add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DelNoPermissionAdmin",
            Router: `/edb_no_permission/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EdbNoPermissionList",
            Router: `/edb_no_permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ModifyNoPermissionAdmin",
            Router: `/edb_no_permission/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoClassify",
            Router: `/eia_steo/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoData",
            Router: `/eia_steo/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EiaSteoSearchList",
            Router: `/eia_steo/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportBaiinfoList",
            Router: `/export/baiinfoList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportGlList",
            Router: `/export/glList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportLzList",
            Router: `/export/lzList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportLzQuotasData",
            Router: `/export/lzQuotasData`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportSciList",
            Router: `/export/sciList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ExportSmmList",
            Router: `/export/smmList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlClassify",
            Router: `/gl/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlData",
            Router: `/gl/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlFrequency",
            Router: `/gl/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlSearchList",
            Router: `/gl/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "GlSingleData",
            Router: `/gl/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzClassify",
            Router: `/lz/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzData",
            Router: `/lz/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzFrequency",
            Router: `/lz/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "LzSearchList",
            Router: `/lz/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalClassify",
            Router: `/mysteel_chemical/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalData",
            Router: `/mysteel_chemical/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalDetail",
            Router: `/mysteel_chemical/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalFrequency",
            Router: `/mysteel_chemical/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalRefresh",
            Router: `/mysteel_chemical/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MysteelChemicalSearch",
            Router: `/mysteel_chemical/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciClassify",
            Router: `/sci/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddSciClassify",
            Router: `/sci/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSciClassify",
            Router: `/sci/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSciClassify",
            Router: `/sci/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSciClassify",
            Router: `/sci/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciClassifyName",
            Router: `/sci/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciData",
            Router: `/sci/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSciData",
            Router: `/sci/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSci",
            Router: `/sci/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciFrequency",
            Router: `/sci/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSciData",
            Router: `/sci/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetSciData",
            Router: `/sci/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciSearchList",
            Router: `/sci/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SciSingleData",
            Router: `/sci/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmClassify",
            Router: `/smm/classify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "AddSmmClassify",
            Router: `/smm/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSmmClassify",
            Router: `/smm/classify/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSmmClassify",
            Router: `/smm/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSmmClassify",
            Router: `/smm/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmClassifyName",
            Router: `/smm/classify/name`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmData",
            Router: `/smm/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "DeleteSmmData",
            Router: `/smm/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "EditSmm",
            Router: `/smm/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmFrequency",
            Router: `/smm/frequency`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "MoveSmmData",
            Router: `/smm/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "ResetSmmData",
            Router: `/smm/reset`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmSearchList",
            Router: `/smm/search_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:EdbInfoController"],
        beego.ControllerComments{
            Method: "SmmSingleData",
            Router: `/smm/single_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "AddExcelClassify",
            Router: `/excel_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "DeleteExcelClassify",
            Router: `/excel_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "DeleteExcelClassifyCheck",
            Router: `/excel_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "EditExcelClassify",
            Router: `/excel_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "ExcelClassifyItems",
            Router: `/excel_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/excel_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelClassifyController"],
        beego.ControllerComments{
            Method: "ExcelClassifyMove",
            Router: `/excel_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/excel_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Copy",
            Router: `/excel_info/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/excel_info/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/excel_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "AddDraft",
            Router: `/excel_info/draft/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/excel_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/excel_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/excel_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Calculate",
            Router: `/excel_info/table/calculate`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Download",
            Router: `/excel_info/table/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetFirstEdbData",
            Router: `/excel_info/table/first_edb_data_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetFutureDateData",
            Router: `/excel_info/table/future_date_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetHistoryDateData",
            Router: `/excel_info/table/history_date_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetOtherEdbData",
            Router: `/excel_info/table/other_edb_data_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/excel_info/table/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ExcelInfoController"],
        beego.ControllerComments{
            Method: "GetExcelTableData",
            Router: `/excel_info/table_data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/manual/classify/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "AllClassifyList",
            Router: `/manual/classify/all_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "FirstClassifyList",
            Router: `/manual/classify/first`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSetClassifyAll",
            Router: `/manual/set_classify/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserAll",
            Router: `/manual/sysuser/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserClassifySave",
            Router: `/manual/sysuser/classify/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:ManualController"],
        beego.ControllerComments{
            Method: "ManualSysUserSearch",
            Router: `/manual/sysuser/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartAdd",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartAddToClassify",
            Router: `/add_to_classify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ChartList",
            Router: `/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ChartRecommendList",
            Router: `/chart/recommend/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyAdd",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "CompanyPublicClassifyList",
            Router: `/classify/company_public_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "CopyClassifyAndChart",
            Router: `/classify/copy`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyDelete",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyEdit",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ModifyClassifyCompanyPublicStatus",
            Router: `/classify/modify_company_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ModifyClassifyPublicStatus",
            Router: `/classify/modify_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "ClassifyMove",
            Router: `/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "PublicClassifyList",
            Router: `/classify/public_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartDelete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartEdit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "GetMyChartClassifyIdList",
            Router: `/get_mychart_classify_id_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartList",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartMove",
            Router: `/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartSearch",
            Router: `/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:MyChartController"],
        beego.ControllerComments{
            Method: "MyChartSearchByEs",
            Router: `/search_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/predict_classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/predict_classify/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "DeleteCheck",
            Router: `/predict_classify/delete/check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/predict_classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Items",
            Router: `/predict_classify/items`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/predict_classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbClassifyController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/predict_classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/predict_edb_info/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "CalculateBatchSave",
            Router: `/predict_edb_info/calculate/batch/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "BatchCalculateBatchSave",
            Router: `/predict_edb_info/calculate/batch/save/batch`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "CalculateSave",
            Router: `/predict_edb_info/calculate/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "ChartDataList",
            Router: `/predict_edb_info/chart/data/list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "EdbChartList",
            Router: `/predict_edb_info/chart/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "DataList",
            Router: `/predict_edb_info/data`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/predict_edb_info/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/predict_edb_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "FilterByEs",
            Router: `/predict_edb_info/filter_by_es`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "ChartImageSet",
            Router: `/predict_edb_info/image/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/predict_edb_info/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Modify",
            Router: `/predict_edb_info/modify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/predict_edb_info/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "Refresh",
            Router: `/predict_edb_info/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "RefreshAll",
            Router: `/predict_edb_info/refresh/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/data_manage:PredictEdbInfoController"],
        beego.ControllerComments{
            Method: "PredictRuleCalculateByNine",
            Router: `/predict_edb_info/rule/calculate_by_nine`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "ParentList",
            Router: `/parent/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnPermissionController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "BatchAdd",
            Router: `/auth/batch_add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/auth/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/auth/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/auth/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishAuthController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/auth/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/company/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/company/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/company/edit_enabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/company/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/company/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "SavePermission",
            Router: `/company/save_permission`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyController"],
        beego.ControllerComments{
            Method: "ViewList",
            Router: `/company/view_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/company_todo/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "AddPublic",
            Router: `/company_todo/add_public`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Approve",
            Router: `/company_todo/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "DoingList",
            Router: `/company_todo/doing_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/company_todo/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "EditList",
            Router: `/company_todo/edit_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "LastPublicTodo",
            Router: `/company_todo/last_public_todo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishCompanyTodoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/company_todo/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportController"],
        beego.ControllerComments{
            Method: "ListClassify",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailCallBackController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailCallBackController"],
        beego.ControllerComments{
            Method: "SendCallBack",
            Router: `/email/send/call_back`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/email/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/email/editEnabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "ImportListMatch",
            Router: `/email/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/email/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "LogList",
            Router: `/email/log_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "MoveToCurrent",
            Router: `/email/moveToCurrent`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "PvList",
            Router: `/email/pv_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/email/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "VideoResend",
            Router: `/email/video/resend`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "VideoSend",
            Router: `/email/video/send`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishReportEmailController"],
        beego.ControllerComments{
            Method: "ViewList",
            Router: `/email/view_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverDelete",
            Router: `/video/cover/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverList",
            Router: `/video/cover/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "CoverSave",
            Router: `/video/cover/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/video/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/video/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "PublishVideo",
            Router: `/video/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "PublishCancleVideo",
            Router: `/video/publish/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/english_report:EnglishVideoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/video/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "ContractList",
            Router: `/contract_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "EditSign",
            Router: `/edit_sign`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "Enable",
            Router: `/enable`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "MoveSeller",
            Router: `/move_seller`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "OperateRecordList",
            Router: `/operate_record_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "RemoveSign",
            Router: `/remove_sign`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessController"],
        beego.ControllerComments{
            Method: "Signing",
            Router: `/signing`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "SystemApiConfig",
            Router: `/api/config/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "SystemApiConfigSet",
            Router: `/api/config/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/menu/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/menu/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "IconAdd",
            Router: `/menu/icon/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "IconList",
            Router: `/menu/icon/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/menu/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "SaveRelate",
            Router: `/menu/relate/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_business:EtaBusinessMenuController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/menu/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/classify/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoClassifyController"],
        beego.ControllerComments{
            Method: "Tree",
            Router: `/classify/tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/tag/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/tag/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/tag/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/eta_training_video:EtaTrainingVideoTagController"],
        beego.ControllerComments{
            Method: "Remove",
            Router: `/tag/remove`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "AddClassify",
            Router: `/classify/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "DelClassify",
            Router: `/classify/delete`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "EditClassify",
            Router: `/classify/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "ListClassify",
            Router: `/classify/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "ClassifyMove",
            Router: `/classify/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocClassifyController"],
        beego.ControllerComments{
            Method: "EditClassifyVisible",
            Router: `/classify/visible/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"],
        beego.ControllerComments{
            Method: "ListReport",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/help_doc:HelpDocController"],
        beego.ControllerComments{
            Method: "PublishReport",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomHide",
            Router: `/custom/hide`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomLabelStatistics",
            Router: `/custom/label/statistics`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomList",
            Router: `/custom/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomOverseasLabelSet",
            Router: `/custom/overseas_label_set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomStatistics",
            Router: `/custom/statistics`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "CustomStatusSet",
            Router: `/custom/status_set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "SaleList",
            Router: `/sale/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/overseas_custom:OverseasCustomController"],
        beego.ControllerComments{
            Method: "SaleSave",
            Router: `/sale/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Accept",
            Router: `/accept`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Back",
            Router: `/back`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "CalendarList",
            Router: `/calendar/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "CompanyDetail",
            Router: `/company/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "CompanySearch",
            Router: `/company/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "FeedbackList",
            Router: `/feedback/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "MattersAdd",
            Router: `/matters/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "MattersDelete",
            Router: `/matters/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "MattersList",
            Router: `/matters/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "MattersUpdate",
            Router: `/matters/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "MyCalendarDetail",
            Router: `/my/calendar/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "OverseasCalendarList",
            Router: `/overseas/calendar/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "OverseasCustomReportCalendarList",
            Router: `/overseas_custom/calendar/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "OverseasResearcherReportList",
            Router: `/overseas_custom/researcher/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "OverseasSellerReportList",
            Router: `/overseas_custom/seller/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "OverseasCustomCalendarAdminList",
            Router: `/overseas_custom/sys_user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "PublicMeetingDetail",
            Router: `/public_meeting/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "QuestionList",
            Router: `/question/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "QuestionAdd",
            Router: `/question/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "CalendarSummaryExport",
            Router: `/question/summary/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "CalendarSummaryList",
            Router: `/question/summary/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "Refuse",
            Router: `/refuse`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "AdminList",
            Router: `/report/admin/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ReportCalendarList",
            Router: `/report/calendar/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ChoiceResearcher",
            Router: `/report/choice/researcher`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherBusinessTrip",
            Router: `/report/researcher/business_trip`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherReportExport",
            Router: `/report/researcher/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherReportList",
            Router: `/report/researcher/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SellerReportList",
            Router: `/report/seller/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SpecialReportList",
            Router: `/report/special/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherCalendarDetail",
            Router: `/researcher/calendar/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "ResearcherList",
            Router: `/researcher/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SellerCalendarDetail",
            Router: `/seller/calendar/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SendFeedback",
            Router: `/send/feedback`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SubmitFeedback",
            Router: `/submit/feedback`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "SubmitFeedbackList",
            Router: `/submit/feedback/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarController"],
        beego.ControllerComments{
            Method: "WriteFeedback",
            Router: `/write/feedback`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/rs_calendar_meeting_user/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/rs_calendar_meeting_user/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/roadshow:CalendarMeetingUserController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/rs_calendar_meeting_user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Apply",
            Router: `/applySealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Approved",
            Router: `/approvedSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Cancel",
            Router: `/cancelSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "CompanySearch",
            Router: `/company/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/delSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/editSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "AffiliatedCompanyList",
            Router: `/getAffiliatedCompany`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/getApprovalPageList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "OperationList",
            Router: `/getOperationList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/getSealApprovalDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Invalid",
            Router: `/invalidSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "Reject",
            Router: `/rejectSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "SealCodeSearch",
            Router: `/sealcode/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "SealdetailById",
            Router: `/sealdetail/by_sealid`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealApprovalController"],
        beego.ControllerComments{
            Method: "VerifierEdit",
            Router: `/verifierEditSealApproval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/seal:SealController"],
        beego.ControllerComments{
            Method: "UploadCheckBackFile",
            Router: `/uploadCheckBackFile`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/statistic:StatisticRaiDataSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/statistic:StatisticRaiDataSummaryController"],
        beego.ControllerComments{
            Method: "RaiDataSummaryDetail",
            Router: `/rai_data_summary/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/statistic:StatisticRaiDataSummaryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/statistic:StatisticRaiDataSummaryController"],
        beego.ControllerComments{
            Method: "RaiDataSummaryList",
            Router: `/rai_data_summary/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/activity/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "CancelQs",
            Router: `/activity/cancel_qs`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ComeInList",
            Router: `/activity/comein/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ComeInShare2Seller",
            Router: `/activity/comein/share2seller`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ComeInUserList",
            Router: `/activity/comein/user_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ExportComeInUserList",
            Router: `/activity/comein/user_list/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "CreateQs",
            Router: `/activity/create_qs`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "DelPublish",
            Router: `/activity/del_publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/activity/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/activity/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/activity/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/activity/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "QsShare2Seller",
            Router: `/activity/qs_share2seller`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "QsList",
            Router: `/activity/quanshi/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "QsUserList",
            Router: `/activity/quanshi/user_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ExportQsUserList",
            Router: `/activity/quanshi/user_list/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ActivityTypeList",
            Router: `/activity/type/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ActivityTypeTelList",
            Router: `/activity/type/tel_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "UnPublish",
            Router: `/activity/unpublish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityController"],
        beego.ControllerComments{
            Method: "ReportList",
            Router: `/report/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/activity_register/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"],
        beego.ControllerComments{
            Method: "CancelRegister",
            Router: `/activity_register/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/activity_register/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"],
        beego.ControllerComments{
            Method: "RegisterList",
            Router: `/activity_register_user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivityRegisterController"],
        beego.ControllerComments{
            Method: "UserList",
            Router: `/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/speaker/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"],
        beego.ControllerComments{
            Method: "DelCheck",
            Router: `/speaker/del_check`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/speaker/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ActivitySpeakerController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/speaker/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/apply_record/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "UserApplyList",
            Router: `/apply_record/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "ApplyExport",
            Router: `/apply_record/listV2/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "MarkGroup",
            Router: `/apply_record/mark_group`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "MarkHandle",
            Router: `/apply_record/mark_handle`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ApplyRecordController"],
        beego.ControllerComments{
            Method: "DelPotentialUser",
            Router: `/potential/user/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:BulletChatController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:BulletChatController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/bullet_chat/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:BulletChatController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:BulletChatController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/bullet_chat/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "ExportChartCompanyAuthCensusList",
            Router: `/chartCensus/exportChartCompanyAuthCensusList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "ExportChartVisitCensusList",
            Router: `/chartCensus/exportChartVisitCensusList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "ExportChartVisitDetailCensusList",
            Router: `/chartCensus/exportChartVisitDetailCensusList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "GetChartCompanyAuthCensusList",
            Router: `/chartCensus/getCompanyAuthCensusList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "GetCompanyChartVisitDetail",
            Router: `/chartCensus/getCompanyChartVisitDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "GetChartVisitDetailCensusList",
            Router: `/chartCensus/getVisitDetailList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ChartCensusController"],
        beego.ControllerComments{
            Method: "GetChartVisitCensusList",
            Router: `/chartCensus/getVisitList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "AllCommentList",
            Router: `/comment/all_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "DeleteComment",
            Router: `/comment/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "SetHot",
            Router: `/comment/hot`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/comment/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "OtherProductList",
            Router: `/comment/product`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "AddReply",
            Router: `/comment/reply/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "DeleteReply",
            Router: `/comment/reply/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "ReportList",
            Router: `/comment/report/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "SetTop",
            Router: `/comment/top`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "DeleteProductComment",
            Router: `/product/comment/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommentController"],
        beego.ControllerComments{
            Method: "ProductCommentList",
            Router: `/product/comment/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionClickLogList",
            Router: `/community/question/click/logs`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "CommentDelete",
            Router: `/community/question/comment/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "CommentHot",
            Router: `/community/question/comment/hot`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "CommentList",
            Router: `/community/question/comment/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionDelete",
            Router: `/community/question/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionDetail",
            Router: `/community/question/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionDistribute",
            Router: `/community/question/distribute`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionEdit",
            Router: `/community/question/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "LikeTeaseList",
            Router: `/community/question/like_tease_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "LikeTeaseListWithQuestion",
            Router: `/community/question/like_tease_question_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionList",
            Router: `/community/question/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "SendDistributeTemplateMsg",
            Router: `/community/question/send_template_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "QuestionTransfer",
            Router: `/community/question/transfer`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityQuestionController"],
        beego.ControllerComments{
            Method: "UserInfo",
            Router: `/community/question/user`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "VideoPlayLogList",
            Router: `/community/video/click/logs`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "CoverDelete",
            Router: `/community/video/cover_delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "CoverList",
            Router: `/community/video/cover_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "CoverSave",
            Router: `/community/video/cover_save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/community/video/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/community/video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/community/video/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/community/video/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "SendMsg",
            Router: `/community/video/send_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "SendTemplateMsg",
            Router: `/community/video/send_template_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:CommunityVideoController"],
        beego.ControllerComments{
            Method: "SendThs",
            Router: `/community/video/send_ths`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:LikeController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:LikeController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/like/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:LikeController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:LikeController"],
        beego.ControllerComments{
            Method: "ReportList",
            Router: `/like/report/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/pdf/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/pdf/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/pdf/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/pdf/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PdfController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/pdf/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "ClickCensusDetail",
            Router: `/price_driven/click_census_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "ClickCensusList",
            Router: `/price_driven/click_census_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "GetPriceDrivenDetail",
            Router: `/price_driven/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "GetPriceDrivenPermissionTree",
            Router: `/price_driven/permission_tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "SendPriceDrivenTemplateMsg",
            Router: `/price_driven/send_template_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "SendPriceDrivenThsMsg",
            Router: `/price_driven/send_ths_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "SwitchPriceDrivenPermissionState",
            Router: `/price_driven/switch_permission_state`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:PriceDrivenController"],
        beego.ControllerComments{
            Method: "UpdatePriceDriven",
            Router: `/price_driven/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ProductCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ProductCensusController"],
        beego.ControllerComments{
            Method: "UserVisitCount",
            Router: `/product_census/user/visit_count`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ProductCensusController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ProductCensusController"],
        beego.ControllerComments{
            Method: "UserVisitCountDetail",
            Router: `/product_census/user/visit_count_detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "GetPermission",
            Router: `/road/permission`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "VideoPlayLogList",
            Router: `/road/video/click/logs`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/road/video/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/road/video/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/road/video/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/road/video/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "SendMsg",
            Router: `/road/video/send_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "SendTemplateMsg",
            Router: `/road/video/send_template_msg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "SendThs",
            Router: `/road/video/send_ths`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "SimpleReportList",
            Router: `/road/video/simple_report_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:RoadVideoController"],
        beego.ControllerComments{
            Method: "TwoWeekClassifyList",
            Router: `/road/video/two_week_classify_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "AddThsSentConf",
            Router: `/ths_send/config/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "DeleteThsSentConf",
            Router: `/ths_send/config/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "EditThsSentConf",
            Router: `/ths_send/config/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "ThsSentConfList",
            Router: `/ths_send/config/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/ths_send/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "ModifyPushTime",
            Router: `/ths_send/modify_push_time`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:ThsSendController"],
        beego.ControllerComments{
            Method: "ReportTypeList",
            Router: `/ths_send/report_type`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceBroadcastController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceBroadcastController"],
        beego.ControllerComments{
            Method: "VoiceBroadcastDetail",
            Router: `/voice/broadcast/deatil`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceBroadcastController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceBroadcastController"],
        beego.ControllerComments{
            Method: "VoiceBroadcastList",
            Router: `/voice/broadcast/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"],
        beego.ControllerComments{
            Method: "AddVoiceSection",
            Router: `/voice/section/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"],
        beego.ControllerComments{
            Method: "EditVoiceSection",
            Router: `/voice/section/edit`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers/yb:VoiceSectionController"],
        beego.ControllerComments{
            Method: "VoiceSectionList",
            Router: `/voice/section/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "GetClassify",
            Router: `/getClassify`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "ListBanner",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Amount",
            Router: `/research_statistics/amount`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "StatisticsDetail",
            Router: `/research_statistics/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "StatisticsItem",
            Router: `/research_statistics/item`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "StatisticsList",
            Router: `/research_statistics/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "BannerStatistic",
            Router: `/statistic`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:BannerController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "ListClassify",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ClassifyController"],
        beego.ControllerComments{
            Method: "TelListClassify",
            Router: `/tel_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyContract",
            Router: `/apply/contract`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyContractDetail",
            Router: `/apply/contract/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "GetApplyTurnContractType",
            Router: `/apply/contract/getApplyTurnContractType`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyContractHistoryDetail",
            Router: `/apply/contract/history/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyContractHistoryList",
            Router: `/apply/contract/history/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyDelay",
            Router: `/apply/delay`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyReceive",
            Router: `/apply/receive`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyServiceUpdate",
            Router: `/apply/service/update`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyBySystemContract",
            Router: `/apply/systemContract`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyThaw",
            Router: `/apply/thaw`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "ApplyTurnPositive",
            Router: `/apply/turn/positive`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "GetLastContractDetail",
            Router: `/company/last_contract/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "GetLastContractDetailWithoutDate",
            Router: `/company/last_contract/detail/withoutDate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "GetContractApplyDetail",
            Router: `/system_contract/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApplyController"],
        beego.ControllerComments{
            Method: "SearchContractList",
            Router: `/system_contract/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "ApplyRevoke",
            Router: `/apply/revoke`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "ApplyApprove",
            Router: `/approval/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "ApplyDelete",
            Router: `/approval/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "GetApprovalPermissionList",
            Router: `/approval/getApprovalPermissionList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "ApprovalList",
            Router: `/approval/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/approval/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalController"],
        beego.ControllerComments{
            Method: "ApprovalListOld",
            Router: `/approval/list_old`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"],
        beego.ControllerComments{
            Method: "SearchList",
            Router: `/message/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"],
        beego.ControllerComments{
            Method: "MessageList",
            Router: `/message/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyApprovalMessageController"],
        beego.ControllerComments{
            Method: "MessageRead",
            Router: `/message/read`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "AddRenewalReason",
            Router: `/addRenewalReason`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "AddTryOutCompanyReason",
            Router: `/addTryOutCompanyReason`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CheckCompanyInfoRepeat",
            Router: `/check/RepeatCompanyInfo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CheckCompanyInfo",
            Router: `/check/companyInfo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Close",
            Router: `/close`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Close2Loss",
            Router: `/close2loss`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "EditCompanyInfo",
            Router: `/company_info/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CustomerAreaStatistics",
            Router: `/customerAreaStatistics`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "DetailByCreditCode",
            Router: `/detail_by_credit_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "EditTryOutCompanyReason",
            Router: `/editTryOutCompanyReason`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Freeze",
            Router: `/freeze`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "FuzzySearch",
            Router: `/fuzzy/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "ContractList",
            Router: `/getCompanyContract`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "PermissionList",
            Router: `/getCompanyPermission`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanySourceList",
            Router: `/getCompanySourceList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "GetTryOutCompanyList",
            Router: `/getTryOutCompanyList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "MoveSeller",
            Router: `/move/seller`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "PotentialUserDeal",
            Router: `/potential/user/deal`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "PotentialUserDelete",
            Router: `/potential/user/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "PotentialUserList",
            Router: `/potential/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "PotentialUserMove",
            Router: `/potential/user/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "ApplyRecordPotentialUserMove",
            Router: `/potential/user/moveByApplyRecord`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Receive",
            Router: `/receive`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "ReceiveList",
            Router: `/receive/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "RemarkList",
            Router: `/remark`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "AddRemark",
            Router: `/remark/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "DelRemark",
            Router: `/remark/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "RenewReasonList",
            Router: `/renewReasonList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "RoadShowList",
            Router: `/roadShowList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "SearchList",
            Router: `/search/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyShare",
            Router: `/share`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyShareList",
            Router: `/share/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyShareListByCity",
            Router: `/share/list/city`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyShareMark",
            Router: `/share/mark`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "MoveShareSeller",
            Router: `/share/moveSeller`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyShareAddRemark",
            Router: `/share/remark/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "Suspend",
            Router: `/suspend`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "UpdateTryStage",
            Router: `/update/tryStage`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "EditUserOutboundMobile",
            Router: `/user/edit/outbound_mobile`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "CompanyUserExport",
            Router: `/user/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyController"],
        beego.ControllerComments{
            Method: "UserMove",
            Router: `/user/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyIndustryController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyIndustryController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/industry/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "ListByContract",
            Router: `/contract_permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "PermissionAddTryOut",
            Router: `/permission/add/try/out`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "PermissionLook",
            Router: `/permission/look`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "PermissionLookSando",
            Router: `/permission/lookSando`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyPermissionController"],
        beego.ControllerComments{
            Method: "PermissionVariety",
            Router: `/permission/variety`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyProcessController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyProcessController"],
        beego.ControllerComments{
            Method: "ProcessList",
            Router: `/process/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"],
        beego.ControllerComments{
            Method: "ChangePermission",
            Router: `/receive/permission/change`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/receive/seller`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyReceiveController"],
        beego.ControllerComments{
            Method: "SellerList",
            Router: `/receive/seller/group`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyAscribeAdd",
            Router: `/company_ascribe/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyAscribeList",
            Router: `/company_ascribe/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyContractNoRenewedAscribeAdd",
            Router: `/company_contract_no_renewed_ascribe/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyContractNoRenewedAscribeAddDetail",
            Router: `/company_contract_no_renewed_ascribe/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyNoRenewedAscribeAdd",
            Router: `/company_no_renewed_ascribe/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyNoRenewedAscribeAddDetail",
            Router: `/company_no_renewed_ascribe/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyNoRenewedNoteAdd",
            Router: `/company_no_renewed_note/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyRenewalController"],
        beego.ControllerComments{
            Method: "CompanyNoRenewedNoteList",
            Router: `/company_no_renewed_note/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "ShareCheckList2",
            Router: `/seller/check/Sharelist2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "InvoicePaymentCheckList",
            Router: `/seller/check/invoice_payment/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckList",
            Router: `/seller/check/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckListV2",
            Router: `/seller/check/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckListRai",
            Router: `/seller/check/list_rai`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckListRaiServerType",
            Router: `/seller/check/list_rai/server_type`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "CheckListForLose",
            Router: `/seller/checkListForLose`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/seller/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "RaiServeSellerList",
            Router: `/seller/rai_serve/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "RoadshowFiccList",
            Router: `/seller/roadshow_ficc/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanySellerController"],
        beego.ControllerComments{
            Method: "ShareSellerList",
            Router: `/seller/share/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"],
        beego.ControllerComments{
            Method: "ServiceRecordAdd",
            Router: `/service_record/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"],
        beego.ControllerComments{
            Method: "ServiceRecordDel",
            Router: `/service_record/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyServiceRecordController"],
        beego.ControllerComments{
            Method: "ServiceRecordList",
            Router: `/service_record/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "CompanyActivityPointsBill",
            Router: `/company/activity/points/bill`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "CompanyActivitySpecialPointsBill",
            Router: `/company/activity/special/points/bill`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "CompanyTryOutDayList",
            Router: `/company/tryOutDayList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/company_todo/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "Approve",
            Router: `/company_todo/approve`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/company_todo/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "EditList",
            Router: `/company_todo/edit_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyTodoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/company_todo/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "GetUserCountByCompanyId",
            Router: `/company_user/total`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "Follow",
            Router: `/follow`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "GetCompanySellerList",
            Router: `/getCompanySellerList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "Import",
            Router: `/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ImportList",
            Router: `/import/list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ImportListMatchDownload",
            Router: `/list/match/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ImportListMatch",
            Router: `/list/match/import`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "CompanyQCCSearch",
            Router: `/potential/company/qccSearch`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "CompanySearch",
            Router: `/potential/company/search`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "PotentialUserExport",
            Router: `/potential/user/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "TemplateDownload",
            Router: `/template`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "UpadteUserYanxuanPermission",
            Router: `/update/user/yananxuan/permission`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "AddUser",
            Router: `/user/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "AddCompanyUserChartClassifyPermission",
            Router: `/user/addChartClassifyPermission`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "DeleteUser",
            Router: `/user/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "DetailUser",
            Router: `/user/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "EditUser",
            Router: `/user/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "EditCompanyUserChartClassifyPermission",
            Router: `/user/editChartClassifyPermission`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/user/exportByCompanyId`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "GetCompanyUserChartClassifyPermissionDetail",
            Router: `/user/getChartClassifyPermissionDetail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ListByReport",
            Router: `/user/listByReport`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ListMoveLog",
            Router: `/user/listMoveLog`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "GetOtherProduct",
            Router: `/user/otherProductList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:CompanyUserController"],
        beego.ControllerComments{
            Method: "ViewReportList",
            Router: `/view/report/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "AddReport",
            Router: `/day_new/add_report`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/day_new/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "EditContentEn",
            Router: `/day_new/edit_content_en`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/day_new/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "RefreshMsg",
            Router: `/day_new/refresh`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "ReportDefault",
            Router: `/day_new/report_default`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "ReportDefaultSave",
            Router: `/day_new/report_default/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:DayNewController"],
        beego.ControllerComments{
            Method: "TranslateContent",
            Router: `/day_new/translate`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "AccountTransfer",
            Router: `/account/transfer`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "AccountList",
            Router: `/apply/accountlist`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "Approval",
            Router: `/apply/approval`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "ApplyDel",
            Router: `/apply/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "ApplyEnable",
            Router: `/apply/enable`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "ApplyList",
            Router: `/apply/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "MyList",
            Router: `/apply/myList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "ApplyReject",
            Router: `/apply/reject`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "ApplyRevoke",
            Router: `/apply/revoke`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "EnableAccountList",
            Router: `/enable/account/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnaireAnswerList",
            Router: `/questionnaire/answerList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnairesDel",
            Router: `/questionnaire/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnaireDetail",
            Router: `/questionnaire/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnaireDetailList",
            Router: `/questionnaire/detailList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnaireList",
            Router: `/questionnaire/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnairesSave",
            Router: `/questionnaire/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ETATrialController"],
        beego.ControllerComments{
            Method: "QuestionnairesStatistical",
            Router: `/questionnaire/statistical`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"],
        beego.ControllerComments{
            Method: "Del",
            Router: `/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:EtaVersionUpdateLogController"],
        beego.ControllerComments{
            Method: "PageList",
            Router: `/page_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/full/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"],
        beego.ControllerComments{
            Method: "Export",
            Router: `/full/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/full/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"],
        beego.ControllerComments{
            Method: "PermissionLook",
            Router: `/full/permission/look`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:FullCompanyController"],
        beego.ControllerComments{
            Method: "CompanyUserExport",
            Router: `/full/user/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:GroupSendMsgController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:GroupSendMsgController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:GroupSendMsgController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:GroupSendMsgController"],
        beego.ControllerComments{
            Method: "GetLabelList",
            Router: `/label_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:MaycurController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:MaycurController"],
        beego.ControllerComments{
            Method: "SyncCompanyProfile",
            Router: `/company_profile/sync`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:MaycurOpenController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:MaycurOpenController"],
        beego.ControllerComments{
            Method: "DailySyncCompanyProfile",
            Router: `/company_profile/daily_sync`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"],
        beego.ControllerComments{
            Method: "OfficialUserConfirm",
            Router: `/official/user/confirm`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"],
        beego.ControllerComments{
            Method: "OfficialUserList",
            Router: `/official/user/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"],
        beego.ControllerComments{
            Method: "OfficialUserListExport",
            Router: `/official/user/list/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:OfficialUserController"],
        beego.ControllerComments{
            Method: "OfficialUserMarkGroup",
            Router: `/official/user/mark_group`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:PdfToImgCommonController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:PdfToImgCommonController"],
        beego.ControllerComments{
            Method: "PdfToImgConvert",
            Router: `/convert`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/chapter_type/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportChapterTypeController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportChapterTypeController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/chapter_type/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekReportChapterTypeList",
            Router: `/getDayWeekReportChapterTypeList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetDayWeekReportPauseTime",
            Router: `/getDayWeekReportPauseTime`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "GetStopDayWeekReportChapterTypeList",
            Router: `/getStopDayWeekReportChapterTypeList`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SetDayWeekReportEnableRule",
            Router: `/setDayWeekReportEnableUpdateRule`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportController"],
        beego.ControllerComments{
            Method: "SetDayWeekReportUpdateRule",
            Router: `/setDayWeekReportUpdateRule`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportUploadCommonController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ReportUploadCommonController"],
        beego.ControllerComments{
            Method: "UploadImg",
            Router: `/uploadImg`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResearchGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResearchGroupController"],
        beego.ControllerComments{
            Method: "GetAdminResearchGroup",
            Router: `/research_group/admin_group`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResearchGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResearchGroupController"],
        beego.ControllerComments{
            Method: "GetResearchGroupList",
            Router: `/research_group/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/image/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "UploadV2",
            Router: `/image/uploadV2`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "OssSTSToken",
            Router: `/oss/get_sts_token`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "UploadImageBase64",
            Router: `/upload_image_base64`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "VideoUpload",
            Router: `/video/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:ResourceController"],
        beego.ControllerComments{
            Method: "VoiceUpload",
            Router: `/voice/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyContractPercentageList",
            Router: `/merge_company/company_contract_percentage/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyContractPercentageListV2",
            Router: `/merge_company/company_contract_percentage/listV2`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyContractPercentageListExport",
            Router: `/merge_company/company_contract_percentage/list_export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyContractPermissionList",
            Router: `/merge_company/company_contract_permission/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "GetYearList",
            Router: `/merge_company/get_year_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "MergeCompanyList",
            Router: `/merge_company_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyPreviousDetail",
            Router: `/merge_company_previous/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticCompanyMergerController"],
        beego.ControllerComments{
            Method: "CompanyPreviousLastYear",
            Router: `/merge_company_previous/last_year`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "InvoicePaymentList",
            Router: `/census/invoice_payment/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "CompanyContractList",
            Router: `/company_contract_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "SimpleList",
            Router: `/contract/service/simple`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "ContractDetailList",
            Router: `/contract_detail_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "ContractList",
            Router: `/contract_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "Home",
            Router: `/home`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "IncomeList",
            Router: `/income_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "IncrementalCompanyListExport",
            Router: `/incremental_company/export`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "IncrementalCompanyList",
            Router: `/incremental_company_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "MoreRenewReason",
            Router: `/more_renew_reason`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "CompanyList",
            Router: `/report/company_list`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "IncrementalCompanyReport",
            Router: `/report/incremental_company`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "RenewCompanyStatistics",
            Router: `/report/renew_company`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "TodoCompanyReport",
            Router: `/report/seller_company_todo`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "StackCompanyReport",
            Router: `/report/stack_company`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "UnusualRenewCompanyStatistics",
            Router: `/report/unusual_renew_company`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "UnusualRenewCompanyList",
            Router: `/report/unusual_renew_company/chart`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "StackCompanyList",
            Router: `/stack_company_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "StackCompanyListRai",
            Router: `/stack_company_list_rai`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticReportController"],
        beego.ControllerComments{
            Method: "WillExpireList",
            Router: `/will_expire_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerYbChartCollectLog",
            Router: `/report/seller_chart_collect_log`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "ChartCollectList",
            Router: `/report/seller_chart_collect_log/detail`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerChartCollectUserLog",
            Router: `/report/seller_chart_collect_log/user`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerCollectLog",
            Router: `/report/seller_collect_log`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "CollectList",
            Router: `/report/seller_collect_log/detail`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerCollectUserLog",
            Router: `/report/seller_collect_log/user`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerYbLog",
            Router: `/report/seller_yb_log`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:StatisticYbLogController"],
        beego.ControllerComments{
            Method: "SellerYbUserLog",
            Router: `/report/seller_yb_log/user`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/sysuser/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "SetConfig",
            Router: `/sysuser/config/set`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/sysuser/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/sysuser/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "EditEnabled",
            Router: `/sysuser/editEnabled`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "ListSysuser",
            Router: `/sysuser/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "Move",
            Router: `/sysuser/move`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysAdminController"],
        beego.ControllerComments{
            Method: "ResetPass",
            Router: `/sysuser/reset_pass`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/department/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/department/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/department/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysDepartmentController"],
        beego.ControllerComments{
            Method: "ListDepartment",
            Router: `/department/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"],
        beego.ControllerComments{
            Method: "Detail",
            Router: `/flow/detail`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/flow/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysFlowController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/flow/user`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/group/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/group/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/group/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysGroupController"],
        beego.ControllerComments{
            Method: "SetSort",
            Router: `/group/set_sort`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "AddAdmin",
            Router: `/role/admin/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "DeleteAdmin",
            Router: `/role/admin/del`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/role/admin/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleAdminController"],
        beego.ControllerComments{
            Method: "SellerList",
            Router: `/role/seller/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysMenuButtons",
            Router: `/menu/buttons`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysMenuList",
            Router: `/menu/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/role/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "AllSysRole",
            Router: `/role/all`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/role/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/role/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "ListSysRole",
            Router: `/role/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenusAdd",
            Router: `/role/menu/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysRoleController"],
        beego.ControllerComments{
            Method: "SysRoleMenusList",
            Router: `/role/menu/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Add",
            Router: `/team/add`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/team/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysTeamController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/team/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "CheckPwd",
            Router: `/check_pwd`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "GetEtaForumAdminAuthCode",
            Router: `/forum_admin/auth_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "GetEtaAuthCode",
            Router: `/get_eta_auth_code`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserAuthController"],
        beego.ControllerComments{
            Method: "ModifyPwd",
            Router: `/modify/pwd`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "AuthCodeLogin",
            Router: `/auth_code_login`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "Login",
            Router: `/login`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:SysUserController"],
        beego.ControllerComments{
            Method: "Uuid",
            Router: `/uuid`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "AreaCodeList",
            Router: `/area_code/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetAccountGet",
            Router: `/forget/account_get`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetCodeVerify",
            Router: `/forget/code_verify`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "ForgetResetPass",
            Router: `/forget/reset_pass`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "GenerateCaptcha",
            Router: `/get_captcha`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "Login",
            Router: `/login`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:UserLoginController"],
        beego.ControllerComments{
            Method: "GetVerifyCode",
            Router: `/verify_code`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "ClassifyList",
            Router: `/variety_tag/classify_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "ClassifySave",
            Router: `/variety_tag/classify_save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "ClassifyState",
            Router: `/variety_tag/classify_state`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "TagList",
            Router: `/variety_tag/tag_list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "TagSave",
            Router: `/variety_tag/tag_save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "TagState",
            Router: `/variety_tag/tag_state`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VarietyTagController"],
        beego.ControllerComments{
            Method: "TagTree",
            Router: `/variety_tag/tag_tree`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "Delete",
            Router: `/delete`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "Edit",
            Router: `/edit`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "List",
            Router: `/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "Publish",
            Router: `/publish`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "PublishCancel",
            Router: `/publish/cancel`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "Save",
            Router: `/save`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VideoController"],
        beego.ControllerComments{
            Method: "TagsList",
            Router: `/tags/list`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VoiceCommonController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VoiceCommonController"],
        beego.ControllerComments{
            Method: "Download",
            Router: `/download`,
            AllowHTTPMethods: []string{"get"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

    beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VoiceController"] = append(beego.GlobalControllerRouter["hongze/hz_crm_api/controllers:VoiceController"],
        beego.ControllerComments{
            Method: "Upload",
            Router: `/upload`,
            AllowHTTPMethods: []string{"post"},
            MethodParams: param.Make(),
            Filters: nil,
            Params: nil})

}
